var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
let jwt = require('jsonwebtoken');
const AWS = require('aws-sdk');
var path = require('path');
const { log } = require('console');



var SFA_Master = function (data) {

};



SFA_Master.getAttendanceTypeData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        var queryString = "SELECT tg_master_attendance_type.* FROM tg_master_attendance_type WHERE status  = ? " + whereCondition + " ORDER BY ID DESC";
        var filter = [1];

        console.log('queryString', queryString);
        console.log('filter', filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getTodayAttendanceData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var queryString = "SELECT tg_attendance.*, IF(tg_attendance.filename != '',CONCAT('" + postData.image_app_path + "', tg_attendance.filename), '') as filename_path ,  IF(tg_attendance.filename_stop != '',CONCAT('" + postData.image_app_path + "', tg_attendance.filename_stop), '') as filename_stop_path  FROM tg_attendance WHERE  tg_attendance.deleted = ?  AND tg_attendance.user_id  = ? AND tg_attendance.attend_date  = ?";
        var filter = [0, postData.sfa_app_user_id, postData.attend_date];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log('res',res);
                var data = {};
                if (res.length) {
                    data = res[0];
                    data.message = data.stop_time != null ? 'Attendance already Stopped for the day' : 'Attendance already punched';
                }
                resolve(data);
            }
        });
    });
};



SFA_Master.getDetailAttendanceData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var queryString = "SELECT tg_attendance.* FROM tg_attendance WHERE  tg_attendance.id = ?";
        var filter = [postData.attendance_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log('res',res);
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getGoogleKmCheckinSum = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDate = moment(new Date()).format('YYYY-MM-DD');


        var whereCondition = '';
        var queryString = "SELECT IF(SUM(tg_checkin.google_km),SUM(tg_checkin.google_km), 0) as google_km FROM tg_checkin WHERE  tg_checkin.user_id = ? AND tg_checkin.checkin_date = ?";
        var filter = [postData.sfa_app_user_id, nowDate];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log('res',res);
                var data = {};
                if (res.length) {
                    data = res[0].google_km ? res[0].google_km.toFixed(2) : 0;
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.addAttendanceData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var insertData = {
            type: postData.attendance_type ? postData.attendance_type : '',
            description: postData.description ? postData.description : '',
            user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            user_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            user_mobile_no: postData.sfa_app_user_mobile ? postData.sfa_app_user_mobile : '',
            mode: postData.mode ? postData.mode : '',
            odo_reading_start: postData.odo_reading ? postData.odo_reading : 0,
            start_lat: postData.start_lat ? postData.start_lat : '',
            start_lng: postData.start_lng ? postData.start_lng : '',
            start_address: postData.start_address ? postData.start_address : '',
            start_time: postData.start_time ? postData.start_time : '00:00:00',
            attend_date: postData.attend_date ? postData.attend_date : '0000-00-00',
            filename: postData.filename ? postData.filename : '',
            created_on: nowDateTime,
            deleted: 0
        }


        var queryString = "INSERT INTO tg_attendance set ?";

        db.query(queryString, insertData, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {

                if (res.insertId) {

                    var updateUserLastLatLngData = {
                        user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
                        last_lat: postData.start_lat ? postData.start_lat : '',
                        last_lng: postData.start_lng ? postData.start_lng : '',
                        last_address: postData.start_address ? postData.start_address : '',
                    }

                    var updateUserLastLatLng = await SFA_Master.updateUserLastLatLng(updateUserLastLatLngData);
                    console.log('updateUserLastLatLng', updateUserLastLatLng);
                }

                resolve(res);
            }
        });
    });
};



SFA_Master.getTodayLastCheckinData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var orderByCondition = '';
        if (postData.filter.checkin_date) {
            whereCondition += " AND ((tg_checkin.checkin_date) = '" + moment(new Date(postData.filter.checkin_date)).format('YYYY-MM-DD') + "')";
        }

        if (postData.filter.date_from && postData.filter.date_to) {
            whereCondition += ' AND ( (tg_checkin.checkin_date) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }


        if (postData.filter.customer_id) {
            whereCondition += " AND (tg_checkin.customer_id = '" + postData.filter.customer_id + "')";
        }


        if (postData.filter.team == true) {
            whereCondition += " OR (tg_checkin.user_id IN (" + postData.sfa_app_user_assignedUserIds + ") OR tg_checkin.created_by IN (" + postData.sfa_app_user_assignedUserIds + "))";
        }
        if (postData.filter.order_by == 'ASC') {
            orderByCondition += ' ORDER BY tg_checkin.ID ASC'
        } else {
            orderByCondition += ' ORDER BY tg_checkin.ID DESC'
        }

        var queryString = "SELECT tg_checkin.* FROM tg_checkin WHERE  tg_checkin.deleted = ?  AND tg_checkin.user_id  = ? AND tg_checkin.stop_time IS NOT NULL " + whereCondition + "  " + orderByCondition + " LIMIT 1";
        var filter = [0, postData.sfa_app_user_id];

        console.log('queryString', queryString);
        console.log('filter', filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.updateAttendanceData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            stop_lat: postData.stop_lat ? postData.stop_lat : '',
            stop_lng: postData.stop_lng ? postData.stop_lng : '',
            stop_address: postData.stop_address ? postData.stop_address : '',
            stop_time: postData.stop_time ? postData.stop_time : '',
            total_time: postData.total_time ? postData.total_time : '',
            google_km: postData.google_km ? postData.google_km : 0,
            odo_reading_stop: postData.odo_reading ? postData.odo_reading : 0,
            filename_stop: postData.filename ? postData.filename : '',
            updated_on: nowDateTime,
        }

        // console.log('updateDataValues',updateDataValues);

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_attendance", updateDataValues, postData.attendance_id];

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {

                var updateUserLastLatLngData = {
                    user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
                    last_lat: postData.stop_lat ? postData.stop_lat : '',
                    last_lng: postData.stop_lng ? postData.stop_lng : '',
                    last_address: postData.stop_address ? postData.stop_address : '',
                }

                var updateUserLastLatLng = await SFA_Master.updateUserLastLatLng(updateUserLastLatLngData);
                console.log('updateUserLastLatLng', updateUserLastLatLng);

                resolve(res);
            }
        });
    });
};



SFA_Master.getAttendanceListCount = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        if (postData.attend_month) {
            whereCondition += " AND (DATE_FORMAT(tg_attendance.attend_date,'%Y-%m') = '" + postData.attend_month + "')";
        }
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount  FROM tg_attendance WHERE  user_id  = ?" + whereCondition;
        var filter = [postData.sfa_app_user_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if (res.length) {
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


SFA_Master.getAttendanceListData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        if (postData.attend_month) {
            whereCondition += " AND (DATE_FORMAT(tg_attendance.attend_date,'%Y-%m') = '" + postData.attend_month + "')";
        }
        var queryString = "SELECT tg_attendance.* ,  IF(tg_attendance.filename != '',CONCAT('" + postData.image_app_path + "', tg_attendance.filename), '') as filename_path ,  IF(tg_attendance.filename_stop != '',CONCAT('" + postData.image_app_path + "', tg_attendance.filename_stop), '') as filename_stop_path  FROM tg_attendance WHERE user_id  = ? " + whereCondition + " ORDER BY ID DESC";
        var filter = [postData.sfa_app_user_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getBeatPlanListData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        if (postData.beat_date) {
            whereCondition += " AND (DATE_FORMAT(tg_attendance.beat_date,'%Y-%m') = '" + postData.beat_month + "')";
        }
        var queryString = "SELECT tg_beat_plan_detail.* FROM tg_beat_plan_detail WHERE user_id  = ? AND deleted = ? " + whereCondition + " ORDER BY ID DESC";
        var filter = [postData.sfa_app_user_id, 0];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};





SFA_Master.getLeaveListCount = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        if (postData.filter.status != 'All' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_leave.status = '" + postData.filter.status + "')";
        }

        if (postData.filter.team == true) {
            whereCondition += " AND (tg_leave.user_id IN (" + postData.sfa_app_user_assignedUserIds + ") OR tg_leave.created_by IN (" + postData.sfa_app_user_assignedUserIds + "))";
        } else {
            whereCondition += " AND (tg_leave.user_id = '" + postData.sfa_app_user_id + "')";
        }

        var queryString = "SELECT  IF(COUNT(id),COUNT(id),0) as totalCount  FROM tg_leave WHERE deleted = ? AND  1 = 1 " + whereCondition;
        var filter = [0];


        console.log('queryString', queryString);
        console.log('filter', filter);
        console.log('postData', postData);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if (res.length) {
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


SFA_Master.getLeaveListData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        if (postData.filter.status != 'All' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_leave.status = '" + postData.filter.status + "')";
        }

        if (postData.filter.team == true) {
            whereCondition += " AND (tg_leave.user_id IN (" + postData.sfa_app_user_assignedUserIds + ") OR tg_leave.created_by IN (" + postData.sfa_app_user_assignedUserIds + "))";
        } else {
            whereCondition += " AND (tg_leave.user_id = '" + postData.sfa_app_user_id + "')";
        }

        var queryString = "SELECT tg_leave.* FROM tg_leave WHERE deleted = ? AND 1 = 1 " + whereCondition + " ORDER BY ID DESC";
        var filter = [0];

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getLeaveTypeData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        var queryString = "SELECT tg_master_leave_type.* FROM tg_master_leave_type WHERE status  = ? " + whereCondition + " ORDER BY ID DESC";
        var filter = [1];

        console.log('queryString', queryString);
        console.log('filter', filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.addLeaveData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            type: postData.type ? postData.type : '',
            user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            subject: postData.subject ? postData.subject : '',
            description: postData.description ? postData.description : '',
            start_date: postData.start_date ? postData.start_date : '0000-00-00',
            end_date: postData.end_date ? postData.end_date : '0000-00-00',
            status: postData.status ? postData.status : 'Pending',
            total_days: postData.total_days ? postData.total_days : 0,
            created_on: nowDateTime,
            created_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            created_by_type: postData.sfa_app_user_type ? postData.sfa_app_user_type : '',
            created_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            deleted: 0,
        }

        var queryString = "INSERT INTO tg_leave set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.updateStatusLeaveData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            branch_head_status_remark: postData.remark ? postData.remark : '',
            branch_head_status_on: nowDateTime ? nowDateTime : '',
            branch_head_status_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : '',
            branch_head_status_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            branch_head_status: postData.status ? postData.status : '',
            updated_on: nowDateTime ? nowDateTime : '',
        }

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_leave", updateDataValues, postData.leave_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.deleteLeaveData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            updated_on: nowDateTime,
            deleted: 1
        }

        // console.log('updateDataValues',updateDataValues);

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_leave", updateDataValues, postData.leave_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




SFA_Master.getCheckinListCount = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        if (postData.filter.checkin_date) {
            whereCondition += " AND ((tg_checkin.checkin_date) = '" + moment(new Date(postData.filter.checkin_date)).format('YYYY-MM-DD') + "')";
        }

        if (postData.filter.date_from && postData.filter.date_to) {
            whereCondition += ' AND ( (tg_checkin.checkin_date) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }


        if (postData.filter.customer_id) {
            whereCondition += " AND (tg_checkin.customer_id = '" + postData.filter.customer_id + "')";
        }


        if (postData.filter.team == true) {
            whereCondition += " AND (tg_checkin.user_id IN (" + postData.sfa_app_user_assignedUserIds + ") OR tg_checkin.created_by IN (" + postData.sfa_app_user_assignedUserIds + "))";
        } else {
            whereCondition += " AND (tg_checkin.user_id = '" + postData.sfa_app_user_id + "')";
        }


        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount  FROM tg_checkin WHERE deleted = ? " + whereCondition;
        var filter = [0];

        console.log('queryString', queryString);
        console.log('filter', filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if (res.length) {
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


SFA_Master.getCheckinListData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var orderByCondition = '';
        if (postData.filter.checkin_date) {
            whereCondition += " AND ((tg_checkin.checkin_date) = '" + moment(new Date(postData.filter.checkin_date)).format('YYYY-MM-DD') + "')";
        }

        if (postData.filter.date_from && postData.filter.date_to) {
            whereCondition += ' AND ( (tg_checkin.checkin_date) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }


        if (postData.filter.customer_id) {
            whereCondition += " AND (tg_checkin.customer_id = '" + postData.filter.customer_id + "')";
        }



        if (postData.filter.team == true) {
            whereCondition += " AND (tg_checkin.user_id IN (" + postData.sfa_app_user_assignedUserIds + ") OR tg_checkin.created_by IN (" + postData.sfa_app_user_assignedUserIds + "))";
        } else {
            whereCondition += " AND (tg_checkin.user_id = '" + postData.sfa_app_user_id + "')";
        }


        if (postData.filter.order_by == 'ASC') {
            orderByCondition += ' ORDER BY tg_checkin.ID ASC'
        } else {
            orderByCondition += ' ORDER BY tg_checkin.ID DESC'
        }

        var queryString = "SELECT tg_checkin.*,tg_customer.first_name,tg_customer.last_name, tg_customer.company_name,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.mobile as mobile_no , IF(tg_checkin.doc_filename != '',CONCAT('" + postData.image_app_path + "', tg_checkin.doc_filename), '') as doc_filename_path FROM tg_checkin LEFT JOIN tg_customer ON tg_customer.id = tg_checkin.customer_id WHERE  tg_checkin.deleted = ?  " + whereCondition + " GROUP BY tg_checkin.id  " + orderByCondition;
        var filter = [0];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {

                if (res.length) {
                    var i = res.length - 1;
                    res.forEach(async element => {
                        var getCheckinDocument = await SFA_Master.getCheckinDocument({ id: element.id, image_app_path: postData.image_app_path });
                        // console.log('getCheckinDocument',getCheckinDocument);
                        element.checkin_document = getCheckinDocument.length ? getCheckinDocument : [];
                        if (i == 0) {
                            resolve(res);
                        }
                        i--;
                    });
                } else {
                    resolve(res);
                }
            }
        });
    });
};


SFA_Master.getPendingCheckinList = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var queryString = "SELECT tg_checkin.*,tg_customer.first_name,tg_customer.last_name, tg_customer.company_name,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.mobile as mobile_no FROM tg_checkin LEFT JOIN tg_customer ON tg_customer.id = tg_checkin.customer_id WHERE  tg_checkin.deleted = ?  AND tg_checkin.user_id  = ? AND tg_checkin.stop_time  IS NULL  " + whereCondition + " ORDER BY tg_checkin.ID DESC";
        var filter = [0, postData.sfa_app_user_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getcheckinTypeData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        var queryString = "SELECT tg_customer_type.* FROM tg_customer_type WHERE status  = ? " + whereCondition + " ORDER BY ID DESC";
        var filter = [1];

        console.log('queryString', queryString);
        console.log('filter', filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.addCheckinData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var insertData = {
            user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            customer_id: postData.customer_id ? postData.customer_id : 0,
            cust_type_id: postData.cust_type_id ? postData.cust_type_id : 0,
            cust_type: postData.cust_type ? postData.cust_type : '',
            start_lat: postData.start_lat ? postData.start_lat : '',
            start_lng: postData.start_lng ? postData.start_lng : '',
            start_address: postData.start_address ? postData.start_address : '',
            start_time: postData.start_time ? postData.start_time : '00:00:00',
            checkin_date: postData.checkin_date ? postData.checkin_date : '0000-00-00',
            start_google_km: postData.start_google_km ? postData.start_google_km : 0,
            created_on: nowDateTime,
            created_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            created_by_type: postData.sfa_app_user_type ? postData.sfa_app_user_type : '',
            created_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            updated_on: nowDateTime,
            deleted: 0
        }

        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_checkin set ?";

        db.query(queryString, insertData, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                if (res.insertId) {
                    var updateUserLastLatLngData = {
                        user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
                        last_lat: postData.start_lat ? postData.start_lat : '',
                        last_lng: postData.start_lng ? postData.start_lng : '',
                        last_address: postData.start_address ? postData.start_address : '',
                    }

                    var updateUserLastLatLng = await SFA_Master.updateUserLastLatLng(updateUserLastLatLngData);
                    console.log('updateUserLastLatLng', updateUserLastLatLng);

                    var updateCheckinCount = await SFA_Master.updateCheckinCount(postData);
                    console.log('updateCheckinCount', updateCheckinCount);

                }
                resolve(res);
            }
        });
    });
};


SFA_Master.updateCheckinCount = function (postData) {

    return new Promise(function (resolve, reject) {

        var attend_date = moment(new Date()).format('YYYY-MM-DD');

        var queryString = "UPDATE ?? SET checkin_count = checkin_count + 1 WHERE attend_date = ? AND user_id = ?;"
        var filter = ["tg_attendance", attend_date, postData.sfa_app_user_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.updateCheckinDataLinkedDetail = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        if (postData.update_type == 'followup') {
            var updateDataValues = {
                followup_id: postData.followup_id,
                followup_added: postData.followup_added,
                updated_on: nowDateTime,
            }
        } else if (postData.update_type == 'order') {
            var updateDataValues = {
                order_id: postData.order_id,
                order_added: postData.order_added,
                updated_on: nowDateTime,
            }
        } else {
            var updateDataValues = {
                updated_on: nowDateTime,
            }
        }


        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_checkin", updateDataValues, postData.checkin_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.updateCheckinData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            stop_lat: postData.stop_lat ? postData.stop_lat : '',
            stop_lng: postData.stop_lng ? postData.stop_lng : '',
            stop_address: postData.stop_address ? postData.stop_address : '',
            last_lat: postData.last_lat ? postData.last_lat : '',
            last_lng: postData.last_lng ? postData.last_lng : '',
            last_address: postData.last_address ? postData.last_address : '',
            stop_time: postData.stop_time ? postData.stop_time : '',
            total_time: postData.total_time ? postData.total_time : '',
            google_km: postData.google_km ? postData.google_km : 0,
            stop_google_km: postData.stop_google_km ? postData.stop_google_km : 0,
            remark: postData.remark ? postData.remark : '',
            // doc_filename : postData.document ? postData.document : '',
            updated_on: nowDateTime,
        }

        // console.log('updateDataValues',updateDataValues);

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_checkin", updateDataValues, postData.checkin_id];

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {

                var updateUserLastLatLngData = {
                    user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
                    last_lat: postData.stop_lat ? postData.stop_lat : '',
                    last_lng: postData.stop_lng ? postData.stop_lng : '',
                    last_address: postData.stop_address ? postData.stop_address : '',
                }

                var updateUserLastLatLng = await SFA_Master.updateUserLastLatLng(updateUserLastLatLngData);
                console.log('updateUserLastLatLng', updateUserLastLatLng);


                resolve(res);
            }
        });
    });
};



SFA_Master.detailCheckinData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var queryString = "SELECT tg_checkin.*,CONCAT('" + postData.image_app_path + "', tg_checkin.doc_filename) as doc_filename_path, tg_customer.first_name,tg_customer.last_name, tg_customer.company_name,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.mobile as mobile_no FROM tg_checkin LEFT JOIN tg_customer ON tg_customer.id = tg_checkin.customer_id WHERE  tg_checkin.deleted = ?  AND tg_checkin.id  = ? " + whereCondition + " ORDER BY tg_checkin.ID DESC";
        var filter = [0, postData.checkin_id];


        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                    data.image_app_path = postData.image_app_path;
                    var getCheckinDocument = await SFA_Master.getCheckinDocument(data);
                    // console.log('getCheckinDocument',getCheckinDocument);
                    data.checkin_document = getCheckinDocument.length ? getCheckinDocument : [];
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getCheckinDocument = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var queryString = "SELECT IF(tg_checkin_document.doc_filename != '',CONCAT('" + postData.image_app_path + "', tg_checkin_document.doc_filename), '') as doc_filename_path FROM tg_checkin_document WHERE deleted = ? AND checkin_id = ?";
        var filter = [0, postData.id];

        // console.log('postData',postData);
        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.insertCheckinDocument = function (postData) {
    return new Promise(async function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        const valueData = [];

        postData.document.forEach(x => {
            valueData.push([postData.checkin_id ? postData.checkin_id : 0, x ? x : '', nowDateTime, postData.sfa_app_user_id ? postData.sfa_app_user_id : 0, postData.sfa_app_user_type ? postData.sfa_app_user_type : 0, postData.sfa_app_user_name ? postData.sfa_app_user_name : 0, 0]);
        });

        var sql = "INSERT INTO tg_checkin_document (checkin_id, doc_filename, created_on, created_by, created_by_type, created_by_name, deleted) VALUES ?";
        db.query(sql, [valueData], function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getDistributorNetworkCount = function (postData) {

    return new Promise(function (resolve, reject) {

        console.log('test ==>', postData.sfa_app_user_id);
        console.log('postData', postData);
        // return false;

        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (company_name LIKE '%" + postData.filter.search + "%'  OR site_name LIKE '%" + postData.filter.search + "%'  OR cust_code LIKE '%" + postData.filter.search + "%' OR mobile LIKE '%" + postData.filter.search + "%' )";
        }

        if (postData.filter.cust_type_id) {
            whereCondition += " AND (cust_type_id = '" + postData.filter.cust_type_id + "')";
        }

        if (postData.filter.branch) {
            whereCondition += " AND (branch = '" + postData.filter.branch + "')";
        }

        if (postData.filter.status != 'All' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_customer.stage = '" + postData.filter.status + "')";
        }

        // if(postData.filter.status){
        //     // whereCondition += " AND (status = '"+postData.filter.status+"')"; 
        //     whereCondition += " AND (stage = '"+postData.filter.status+"')"; 
        // }

        // if(postData.filter.is_lead){
        //     whereCondition += " AND (is_lead = '"+postData.filter.is_lead+"')"; 
        // }

        if (postData.filter.created_on) {
            whereCondition += " AND (DATE(tg_customer.created_on) = '" + moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD') + "')";
        }

        if (postData.filter.created_by) {
            whereCondition += " AND (cust_type_id = '" + postData.filter.created_by + "')";
        }

        if (postData.sfa_app_user_assignedDrIds) {
            whereCondition += " AND (tg_customer.id IN (" + postData.sfa_app_user_assignedDrIds + ") OR (tg_customer.created_by IN (" + postData.sfa_app_user_id + ")) )";
        }

        // if(postData.sfa_app_user_assignedStateName){
        //     var sfa_app_user_assignedStateName = postData.sfa_app_user_assignedStateName.length ? postData.sfa_app_user_assignedStateName.join("','") : postData.sfa_app_user_assignedStateName;
        //     whereCondition += " AND (tg_customer.state_name IN ('"+sfa_app_user_assignedStateName+"') )"; 
        // }

        // if(postData.sfa_app_user_assignedBeatPlan?.length){
        //     var sfa_app_user_assignedBeatPlan = postData.sfa_app_user_assignedBeatPlan.length ? postData.sfa_app_user_assignedBeatPlan.join("','") : postData.sfa_app_user_assignedBeatPlan;
        //     whereCondition += " AND (tg_customer.beat IN ('"+sfa_app_user_assignedBeatPlan+"') )"; 
        // }

        console.log('postData', postData);

        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_customer WHERE deleted = ? AND 1 = 1 " + whereCondition
        var filter = [0];

        console.log('queryString', queryString);
        console.log('filter', filter);

        // return false;

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                // console.log('data',data);
                resolve(data);
            }
        });
    });
};


SFA_Master.getDistributorNetworkList = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (company_name LIKE '%" + postData.filter.search + "%'  OR site_name LIKE '%" + postData.filter.search + "%'  OR cust_code LIKE '%" + postData.filter.search + "%' OR mobile LIKE '%" + postData.filter.search + "%' )";
        }

        if (postData.filter.cust_type_id) {
            whereCondition += " AND (cust_type_id = '" + postData.filter.cust_type_id + "')";
        }

        if (postData.filter.branch) {
            whereCondition += " AND (branch = '" + postData.filter.branch + "')";
        }

        if (postData.filter.state_name) {
            whereCondition += " AND (state_name = '" + postData.filter.state_name + "')";
        }

        if (postData.filter.district_name) {
            whereCondition += " AND (district_name = '" + postData.filter.district_name + "')";
        }

        if (postData.filter.city) {
            whereCondition += " AND (city LIKE '%" + postData.filter.city + "%')";
        }

        if (postData.filter.area) {
            whereCondition += " AND (area LIKE '%" + postData.filter.area + "%')";
        }

        if (postData.filter.status != 'All' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_customer.stage = '" + postData.filter.status + "')";
        }

        // if(postData.filter.status){
        //     // whereCondition += " AND (status = '"+postData.filter.status+"')"; 
        //     whereCondition += " AND (stage = '"+postData.filter.status+"')"; 
        // }

        // if(postData.filter.is_lead){
        //     whereCondition += " AND (is_lead = '"+postData.filter.is_lead+"')"; 
        // }

        if (postData.filter.created_on) {
            whereCondition += " AND (DATE(tg_customer.created_on) = '" + moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD') + "')";
        }

        // if(postData.sfa_app_user_assignedDrIds){
        //     whereCondition += " AND (tg_customer.id IN ('"+postData.sfa_app_user_assignedDrIds+"') )"; 
        // }

        if (postData.sfa_app_user_assignedDrIds) {
            whereCondition += " AND (tg_customer.id IN (" + postData.sfa_app_user_assignedDrIds + ") OR (tg_customer.created_by IN (" + postData.sfa_app_user_id + ")) )";
        }

        console.log('postData', postData);

        // if(postData.sfa_app_user_assignedStateName){
        //     var sfa_app_user_assignedStateName = postData.sfa_app_user_assignedStateName.length ? postData.sfa_app_user_assignedStateName.join("','") : postData.sfa_app_user_assignedStateName;
        //     whereCondition += " AND (tg_customer.state_name IN ('"+sfa_app_user_assignedStateName+"') )"; 
        // }

        // if(postData.sfa_app_user_assignedBeatPlan?.length){
        //     var sfa_app_user_assignedBeatPlan = postData.sfa_app_user_assignedBeatPlan.length ? postData.sfa_app_user_assignedBeatPlan.join("','") : postData.sfa_app_user_assignedBeatPlan;
        //     whereCondition += " AND (tg_customer.beat IN ('"+sfa_app_user_assignedBeatPlan+"') )"; 
        // }

        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT id,company_name,site_name, first_name,last_name, cust_code,cust_type,mobile, street, state_name, district_name,city,area,branch,pincode, status  FROM tg_customer WHERE deleted = ? AND 1 = 1 " + whereCondition + " ORDER BY id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getAssignedRetailerNetworkListCount = function (postData) {

    return new Promise(function (resolve, reject) {


        var whereCondition = '';
        if (postData.filter.search) {
            whereCondition += " AND (company_name LIKE '%" + postData.filter.search + "%'  OR site_name LIKE '%" + postData.filter.search + "%'  OR cust_code LIKE '%" + postData.filter.search + "%' OR mobile LIKE '%" + postData.filter.search + "%' )";
        }

        if (postData.filter.cust_type_id) {
            whereCondition += " AND (cust_type_id = '" + postData.filter.cust_type_id + "')";
        }

        if (postData.filter.status != 'All' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_customer.status = '" + postData.filter.status + "')";
        }


        if(postData.appType == 'sfa'){
            var queryString = "SELECT IF(COUNT(tg_customer.id),COUNT(tg_customer.id),0) as totalCount FROM tg_customer LEFT JOIN tg_customer_assigned_user ON tg_customer_assigned_user.customer_id = tg_customer.id WHERE tg_customer_assigned_user.user_id = ? AND  tg_customer.deleted = ?" + whereCondition
        }else{
            var queryString = "SELECT IF(COUNT(tg_customer.id),COUNT(tg_customer.id),0) as totalCount FROM tg_customer LEFT JOIN tg_customer_dealer ON tg_customer_dealer.customer_id = tg_customer.id WHERE tg_customer_dealer.dealer_id = ? AND  tg_customer.deleted = ?" + whereCondition
        }

  
        var filter = [postData.sfa_app_user_id,0];

        console.log('queryString', queryString);
        console.log('filter', filter);

        // return false;

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].totalCount;
                }
                // console.log('data',data);
                resolve(data);
            }
        });
    });
};
SFA_Master.getAssignedRetailerNetworkList = function (postData) {

    console.log('postData', postData);
    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        if (postData.filter.status != 'All' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_customer.status = '" + postData.filter.status + "')";
        }

        if (postData.appType == 'sfa') {
            var queryString = "SELECT tg_customer.*,tg_customer_assigned_user.user_id AS sales_user_id, tg_customer_assigned_user.user_name AS sales_user_name FROM tg_customer LEFT JOIN tg_customer_assigned_user ON tg_customer_assigned_user.customer_id = tg_customer.id WHERE tg_customer.deleted = ? AND tg_customer_assigned_user.user_id = ? "+whereCondition+" "
         

        }
        else {
            var queryString = "SELECT tg_customer.*,tg_customer_dealer.dealer_id AS distributor_id , tg_customer_dealer.name as distributor_name FROM tg_customer LEFT JOIN tg_customer_dealer ON tg_customer_dealer.customer_id = tg_customer.id WHERE tg_customer.deleted = ? AND tg_customer_dealer.dealer_id = ? "+whereCondition+" "
           
        }
        var filter = [0,postData.sfa_app_user_id];


       console.log("query",queryString);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getDistributionNetworkBasicDetail = function (postData) {

    return new Promise(function (resolve, reject) {

        var queryString = "SELECT tg_customer.*,CONCAT('" + postData.image_app_path + "', tg_customer.profile_image) as profile_image_path , IF(tg_customer.cheque_image != '',CONCAT('" + postData.image_app_path + "', tg_customer.cheque_image), '') as cheque_image_path FROM tg_customer WHERE  id = ?"
        var filter = [postData.customer_id];

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    // console.log('getLogDetail',getLogDetail);

                    data = res[0];
                    data.date_of_birth = data.date_of_birth == '0000-00-00' ? '' : data.date_of_birth;
                    data.date_of_anniversary = data.date_of_anniversary == '0000-00-00' ? '' : data.date_of_anniversary;
                    // var getWalletPoints = await Network.getNetworkWalletPoints(postData);
                    // data.wallet_points = getWalletPoints ? getWalletPoints : 0;
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getDistributionNetworkContactDetail = function (postData) {

    return new Promise(function (resolve, reject) {

        var queryString = "SELECT * FROM tg_customer_contact WHERE  customer_id = ? AND deleted = ? ORDER BY id DESC"
        var filter = [postData.customer_id, 0];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getDistributionNetworkDealerDetail = function (postData) {

    return new Promise(function (resolve, reject) {

        var queryString = "SELECT * FROM tg_customer_dealer WHERE  customer_id = ? AND deleted = ? ORDER BY id DESC"
        var filter = [postData.customer_id, 0];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getDistributionNetworkDocumentDetail = function (postData) {

    return new Promise(function (resolve, reject) {

        var queryString = "SELECT tg_customer_document.*,CONCAT('" + postData.image_app_path + "', tg_customer_document.doc_filename) as doc_filename_path,  IF(tg_customer_document.doc_filename_1 != '',CONCAT('" + postData.image_app_path + "', tg_customer_document.doc_filename_1), '') as doc_filename_1_path FROM tg_customer_document WHERE  customer_id = ? AND `deleted` = ? ORDER BY id DESC"
        var filter = [postData.customer_id, 0];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getAssignedUserDetail = function (postData) {

    return new Promise(function (resolve, reject) {

        var queryString = "SELECT * FROM tg_customer_sys_user_assign WHERE  customer_id = ? ORDER BY id DESC"
        var filter = [postData.customer_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getAssignedSalesUserDetail = function (postData) {

    return new Promise(function (resolve, reject) {

        var queryString = "SELECT * FROM tg_customer_assigned_user WHERE  customer_id = ?  AND deleted = ? ORDER BY id DESC"
        var filter = [postData.customer_id, 0];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getDealerPartnerDetail = function (postData) {

    return new Promise(function (resolve, reject) {


        var queryString = "SELECT tg_customer_partner.*, IF(tg_customer_partner.aadhaar_front != '',CONCAT('" + postData.image_app_path + "', tg_customer_partner.aadhaar_front), '') as aadhaar_front_path, IF(tg_customer_partner.pan != '',CONCAT('" + postData.image_app_path + "', tg_customer_partner.pan), '') as pan_path, IF(tg_customer_partner.aadhaar_back != '',CONCAT('" + postData.image_app_path + "', tg_customer_partner.aadhaar_back), '') as aadhaar_back_path FROM tg_customer_partner WHERE  customer_id = ? AND `deleted` = ? ORDER BY id DESC"

        var filter = [postData.customer_id, 0];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getDistributionNetworkLogCount = function (postData) {

    return new Promise(function (resolve, reject) {


        var whereCondition = '';

        if (postData.filter.log_type) {
            whereCondition += " AND (tg_customer_log.type = '" + postData.filter.log_type + "')";
        }

        var queryString = "SELECT  IF(COUNT(id),COUNT(id),0) as totalCount  FROM tg_customer_log WHERE  customer_id = ? " + whereCondition + " ORDER BY id DESC"
        var filter = [postData.customer_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if (res.length) {
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};

SFA_Master.getDistributionNetworkLogDetail = function (postData) {

    return new Promise(function (resolve, reject) {


        var whereCondition = '';

        if (postData.filter.log_type) {
            whereCondition += " AND (tg_customer_log.type = '" + postData.filter.log_type + "')";
        }


        var queryString = "SELECT * FROM tg_customer_log WHERE  customer_id = ? " + whereCondition + " ORDER BY id DESC"
        var filter = [postData.customer_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

SFA_Master.distributionNetworkLogData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            customer_id: postData.customer_id ? postData.customer_id : 0,
            type: postData.type ? postData.type : '',
            description: postData.description ? postData.description : '',
            created_on: nowDateTime,
            created_by: postData.created_by ? postData.created_by : 0,
            created_by_type: postData.created_by_type ? postData.created_by_type : '',
            created_by_name: postData.created_by_name ? postData.created_by_name : '',
        }

        var queryString = "INSERT INTO tg_customer_log set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getExpenseDataCount = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        if (postData.filter.status != 'All' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_expense.status = '" + postData.filter.status + "')";
        }

        if (postData.filter.team == true) {
            whereCondition += " AND (tg_expense.user_id IN (" + postData.sfa_app_user_assignedUserIds + ") OR tg_expense.created_by IN (" + postData.sfa_app_user_assignedUserIds + "))";
        } else {
            whereCondition += " AND (tg_expense.user_id = '" + postData.sfa_app_user_id + "')";
        }


        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT IF(COUNT(tg_expense.id),COUNT(tg_expense.id),0) as totalCount FROM tg_expense  WHERE  1 = 1 AND tg_expense.deleted = ? AND tg_expense.created_by = ? " + whereCondition;
        var filter = [0, postData.sfa_app_user_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if (res.length) {
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


SFA_Master.getExpenseDataList = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        if (postData.filter.status != 'All' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_expense.status = '" + postData.filter.status + "')";
        }

        if (postData.filter.team == true) {
            whereCondition += " AND (tg_expense.user_id IN (" + postData.sfa_app_user_assignedUserIds + ") OR tg_expense.created_by IN (" + postData.sfa_app_user_assignedUserIds + "))";
        } else {
            whereCondition += " AND (tg_expense.user_id = '" + postData.sfa_app_user_id + "')";
        }

        var queryString = "SELECT tg_expense.* FROM tg_expense WHERE  1 = 1 AND tg_expense.deleted = ?  AND tg_expense.created_by = ? " + whereCondition + " ORDER BY tg_expense.id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.sfa_app_user_id, postData.limit, postData.start];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getExpenseData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        var queryString = "SELECT tg_expense.* FROM tg_expense WHERE  1 = 1 AND tg_expense.deleted = ?  AND tg_expense.id = ? " + whereCondition;
        var filter = [0, postData.expense_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getExpenseDataDetail = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        var queryString = "SELECT tg_expense_data.* FROM tg_expense_data WHERE  1 = 1 AND tg_expense_data.deleted = ?  AND tg_expense_data.expense_id = ? " + whereCondition + " ORDER BY tg_expense_data.id DESC";
        var filter = [0, postData.expense_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getMasterExpenseTypeList = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var groupByCondition = '';
        if (postData.filter.parent_id) {
            whereCondition += " AND (parent_id = '" + postData.filter.parent_id + "')";
        } else {
            whereCondition += " AND (is_parent = '1')";
        }

        if (postData.filter.type) {
            whereCondition += " AND (type = '" + postData.filter.type + "')";
        }

        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_master_expense_travel_type.id,tg_master_expense_travel_type.name  FROM tg_master_expense_travel_type WHERE status = ? AND 1 = 1 " + whereCondition + groupByCondition + " ORDER BY ordering ASC";
        var filter = [1];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.updateStatusExpenseData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            branch_head_status_remark: postData.remark ? postData.remark : '',
            branch_head_status_on: nowDateTime ? nowDateTime : '',
            branch_head_status_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : '',
            branch_head_status_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            branch_head_status: postData.status ? postData.status : '',
            updated_on: nowDateTime ? nowDateTime : '',
        }

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_expense", updateDataValues, postData.expense_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.addExpenseData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            type: postData.type ? postData.type : '',
            purpose_of_visit: postData.purpose_of_visit ? postData.purpose_of_visit : '',
            advance_amt: postData.advance_amt ? postData.advance_amt : 0,
            food_total: postData.food_total ? postData.food_total : 0,
            hotel_total: postData.hotel_total ? postData.hotel_total : 0,
            local_conveyance_total: postData.local_conveyance_total ? postData.local_conveyance_total : 0,
            travel_entitlement_total: postData.travel_entitlement_total ? postData.travel_entitlement_total : 0,
            misc_total: postData.misc_total ? postData.misc_total : 0,
            total: postData.total ? postData.total : 0,
            status: postData.status ? postData.status : 'Pending',
            remark: postData.remark ? postData.remark : '',
            created_on: nowDateTime,
            created_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            created_by_type: postData.sfa_app_user_type ? postData.sfa_app_user_type : '',
            created_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            updated_on: nowDateTime,
            deleted: 0
        }

        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_expense set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.addExpenseDetailData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            expense_id: postData.expense_id ? postData.expense_id : 0,
            expense_type: postData.expense_type ? postData.expense_type : '',
            nature_of_expense: postData.nature_of_expense ? postData.nature_of_expense : '',
            date: postData.date ? postData.date : '0000-00-00',
            amount: postData.amount ? postData.amount : 0,
            remark: postData.remark ? postData.remark : '',
            mode_of_travel: postData.mode_of_travel ? postData.mode_of_travel : '',
            city: postData.city ? postData.city : '',
            name: postData.name ? postData.name : '',
            checkin_date: postData.checkin_date ? postData.checkin_date : '0000-00-00',
            checkout_date: postData.checkout_date ? postData.checkout_date : '0000-00-00',
            departure_date_time: postData.departure_date_time ? postData.departure_date_time : '0000-00-00 00:00:00',
            departure_station: postData.departure_station ? postData.departure_station : '',
            arrival_date_time: postData.arrival_date_time ? postData.arrival_date_time : '0000-00-00 00:00:00',
            arrival_station: postData.arrival_station ? postData.arrival_station : '',
            detail_ticket_no: postData.detail_ticket_no ? postData.detail_ticket_no : '',
            travel_distance: postData.travel_distance ? postData.travel_distance : 0,
            created_on: nowDateTime,
            created_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            created_by_type: postData.sfa_app_user_type ? postData.sfa_app_user_type : '',
            created_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            updated_on: nowDateTime,
            deleted: 0
        }

        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_expense_data set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getFollowupListCount = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        if (postData.filter.status == 'Pending' || postData.filter.status == 'Completed') {
            whereCondition += " AND (DATE(tg_followup.followup_date) <= '" + moment(new Date()).format('YYYY-MM-DD') + "')";
        }

        if (postData.filter.status == 'Upcoming') {
            whereCondition += " AND (DATE(tg_followup.followup_date) > '" + moment(new Date()).format('YYYY-MM-DD') + "')";
        }


        if (postData.filter.followup_date) {
            whereCondition = '';
            whereCondition += " AND (DATE(tg_followup.followup_date) = '" + moment(new Date(postData.filter.followup_date)).format('YYYY-MM-DD') + "')";
        }


        if (postData.filter.status != 'All' && postData.filter.status != 'Upcoming' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_followup.status = '" + postData.filter.status + "')";
        }

        if (postData.filter.customer_id) {
            whereCondition += " AND (tg_followup.customer_id = '" + postData.filter.customer_id + "')";
        }

        if (postData.filter.team == true) {
            whereCondition += " AND (tg_followup.user_id IN (" + postData.sfa_app_user_assignedUserIds + ") OR tg_followup.created_by IN (" + postData.sfa_app_user_assignedUserIds + "))";
        } else {
            whereCondition += " AND (tg_followup.user_id = '" + postData.sfa_app_user_id + "')";
        }


        if (postData.filter.date_from && postData.filter.date_to) {
            whereCondition += ' AND ( DATE(tg_followup.followup_date) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }

        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount  FROM tg_followup WHERE deleted = ? " + whereCondition;
        var filter = [0];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if (res.length) {
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


SFA_Master.getFollowupListData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        if (postData.filter.status == 'Pending' || postData.filter.status == 'Completed') {
            whereCondition += " AND (DATE(tg_followup.followup_date) <= '" + moment(new Date()).format('YYYY-MM-DD') + "')";
        }

        if (postData.filter.status == 'Upcoming') {
            whereCondition += " AND (DATE(tg_followup.followup_date) > '" + moment(new Date()).format('YYYY-MM-DD') + "')";
        }


        if (postData.filter.followup_date) {
            whereCondition = '';
            whereCondition += " AND (DATE(tg_followup.followup_date) = '" + moment(new Date(postData.filter.followup_date)).format('YYYY-MM-DD') + "')";
        }


        if (postData.filter.status != 'All' && postData.filter.status != 'Upcoming' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_followup.status = '" + postData.filter.status + "')";
        }

        if (postData.filter.team == true) {
            whereCondition += " AND (tg_followup.user_id IN (" + postData.sfa_app_user_assignedUserIds + ") OR tg_followup.created_by IN (" + postData.sfa_app_user_assignedUserIds + "))";
        } else {
            whereCondition += " AND (tg_followup.user_id = '" + postData.sfa_app_user_id + "')";
        }

        if (postData.filter.date_from && postData.filter.date_to) {
            whereCondition += ' AND ( DATE(tg_followup.followup_date) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }


        if (postData.filter.customer_id) {
            whereCondition += " AND (tg_followup.customer_id = '" + postData.filter.customer_id + "')";
        }

        var queryString = "SELECT tg_followup.*, UNIX_TIMESTAMP(tg_followup.followup_date_time) AS DATE,  tg_customer.first_name,tg_customer.last_name, tg_customer.company_name,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.mobile as mobile_no FROM tg_followup LEFT JOIN tg_customer ON tg_customer.id = tg_followup.customer_id WHERE  tg_followup.deleted = ? " + whereCondition + " ORDER BY DATE DESC";
        var filter = [0];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getFollowupStatusList = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        var queryString = "SELECT id,name FROM tg_master_followup_status WHERE status  = ? " + whereCondition + " ORDER BY ID DESC";
        var filter = [1];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.addFollowUpData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var insertData = {
            user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            customer_id: postData.customer_id ? postData.customer_id : 0,
            cust_type_id: postData.cust_type_id ? postData.cust_type_id : 0,
            cust_type: postData.cust_type ? postData.cust_type : '',
            description: postData.description ? postData.description : '',
            status: 'Pending',
            followup_date_time: postData.followup_date ? moment(postData.followup_date).format('YYYY-MM-DD HH:mm:ss') : '0000-00-00 00:00:00',
            followup_date: postData.followup_date ? moment(postData.followup_date).format('YYYY-MM-DD') : '0000-00-00',
            followup_time: postData.followup_time ? postData.followup_time : '00:00',
            created_on: nowDateTime,
            created_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            created_by_type: postData.sfa_app_user_type ? postData.sfa_app_user_type : '',
            created_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            updated_on: nowDateTime,
            deleted: 0,
            checkin_id: postData.checkin_id ? postData.checkin_id : 0
        }

        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_followup set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.detailFollowupData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var queryString = "SELECT tg_followup.*,tg_customer.first_name,tg_customer.last_name, tg_customer.company_name,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.mobile as mobile_no FROM tg_followup LEFT JOIN tg_customer ON tg_customer.id = tg_followup.customer_id WHERE  tg_followup.deleted = ?  AND tg_followup.id  = ? " + whereCondition + " ORDER BY tg_followup.ID DESC";
        var filter = [0, postData.followup_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};



SFA_Master.updateFollowupStatus = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            status: postData.status ? postData.status : '',
            status_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            status_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            status_remark: postData.status_remark ? postData.status_remark : '',
            status_on: nowDateTime,
            updated_on: nowDateTime,
        }
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_followup", updateDataValues, postData.followup_id];


        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.deleteFollowupData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            updated_on: nowDateTime,
            deleted: 1
        }

        // console.log('updateDataValues',updateDataValues);

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_followup", updateDataValues, postData.followup_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getTravelPlanListCount = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        if (postData.filter.followup_date) {
            whereCondition += " AND (DATE(tg_travel_plan.followup_date) = '" + moment(new Date(postData.filter.followup_date)).format('YYYY-MM-DD') + "')";
        }

        if (postData.filter.status != 'All' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_travel_plan.status = '" + postData.filter.status + "')";
        }


        if (postData.filter.travel_from && postData.filter.travel_to) {
            whereCondition += ' AND ( DATE(tg_travel_plan.travel_from) >=  "' + moment(new Date(postData.filter.travel_from)).format('YYYY-MM-DD') + '" AND DATE(tg_travel_plan.travel_to) <= "' + moment(new Date(postData.filter.travel_to)).format('YYYY-MM-DD') + '" )';
        }

        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount  FROM tg_travel_plan WHERE deleted = ? AND user_id  = ?" + whereCondition;
        var filter = [0, postData.sfa_app_user_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if (res.length) {
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


SFA_Master.getTravelPlanListData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        if (postData.filter.created_on) {
            whereCondition += " AND (DATE(tg_travel_plan.created_on) = '" + moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD') + "')";
        }

        if (postData.filter.status != 'All' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_travel_plan.status = '" + postData.filter.status + "')";
        }

        if (postData.filter.travel_from && postData.filter.travel_to) {
            whereCondition += ' AND ( DATE(tg_travel_plan.travel_from) >=  "' + moment(new Date(postData.filter.travel_from)).format('YYYY-MM-DD') + '" AND DATE(tg_travel_plan.travel_to) <= "' + moment(new Date(postData.filter.travel_to)).format('YYYY-MM-DD') + '" )';
        }


        var queryString = "SELECT tg_travel_plan.*,tg_customer.first_name,tg_customer.last_name, tg_customer.company_name,tg_customer.street,tg_customer.state_name,tg_customer.district_name FROM tg_travel_plan LEFT JOIN tg_customer ON tg_customer.id = tg_travel_plan.customer_id WHERE  tg_travel_plan.deleted = ?  AND tg_travel_plan.user_id  = ? " + whereCondition + " ORDER BY tg_travel_plan.ID DESC";
        var filter = [0, postData.sfa_app_user_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getTravelPlanTypeData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        var queryString = "SELECT tg_master_travel_plan_type.* FROM tg_master_travel_plan_type WHERE status  = ? " + whereCondition + " ORDER BY ID DESC";
        var filter = [1];

        console.log('queryString', queryString);
        console.log('filter', filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.addTravelPlanData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var insertData = {
            user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            customer_id: postData.customer_id ? postData.customer_id : 0,
            cust_type_id: postData.cust_type_id ? postData.cust_type_id : 0,
            cust_type: postData.cust_type ? postData.cust_type : '',
            description: postData.description ? postData.description : '',
            travel_from: postData.travel_from ? postData.travel_from : '0000-00-00',
            travel_to: postData.travel_to ? postData.travel_to : '0000-00-00',
            travel_type: postData.travel_type ? postData.travel_type : '',
            total_days: postData.total_days ? postData.total_days : 0,
            state_name: postData.state_name ? postData.state_name : '',
            district_name: postData.district_name ? postData.district_name : '',
            city: postData.city ? postData.city : '',
            area: postData.area ? postData.area : '',
            status: postData.status ? postData.status : 'Pending',
            created_on: nowDateTime,
            created_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            created_by_type: postData.sfa_app_user_type ? postData.sfa_app_user_type : '',
            created_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            updated_on: nowDateTime,
            deleted: 0
        }

        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_travel_plan set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.updateStatusTravelPlanData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            branch_head_status_remark: postData.remark ? postData.remark : '',
            branch_head_status_on: nowDateTime ? nowDateTime : '',
            branch_head_status_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : '',
            branch_head_status_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            branch_head_status: postData.status ? postData.status : '',
            updated_on: nowDateTime ? nowDateTime : '',
        }

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_travel_plan", updateDataValues, postData.travel_plan_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.detailTravelPlanData = function (postData) {

    return new Promise(function (resolve, reject) {

        var queryString = "SELECT tg_travel_plan.*,tg_customer.first_name,tg_customer.last_name, tg_customer.company_name FROM tg_travel_plan LEFT JOIN tg_customer ON tg_customer.id = tg_travel_plan.customer_id WHERE  tg_travel_plan.deleted = ?  AND tg_travel_plan.id  = ?";
        var filter = [0, postData.travel_plan_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};



SFA_Master.deleteTravelPlanData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            updated_on: nowDateTime,
            deleted: 1
        }

        // console.log('updateDataValues',updateDataValues);

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_travel_plan", updateDataValues, postData.travel_plan_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getLeadTypeData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';


        var whereCondition = '';
        if (postData.loginType == 1) {
            var queryString = "SELECT tg_customer_type.* FROM tg_customer_type WHERE status  = ? AND for_network = ? AND id != ? " + whereCondition + " ORDER BY ID DESC";
            var filter = [1, 1, postData.loginType];
        } else {
            var queryString = "SELECT tg_customer_type.* FROM tg_customer_type WHERE status  = ? AND for_network = ? " + whereCondition + " ORDER BY ID DESC";
            var filter = [1, 1];
        }

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getLeadStageListData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        var queryString = "SELECT id,name FROM tg_master_site_stage WHERE status  = ? " + whereCondition + " ORDER BY ordering ASC";
        var filter = [1];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getLeadSourceListData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        var queryString = "SELECT id,name FROM tg_master_lead_source WHERE status  = ? " + whereCondition + " ORDER BY ordering ASC";
        var filter = [1];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getLeadStatusListData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        var queryString = "SELECT id,name FROM tg_customer_status WHERE status  = ? " + whereCondition + " ORDER BY ordering ASC";
        var filter = [1];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};





SFA_Master.getCustTypeNameById = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        var queryString = "SELECT tg_customer_type.name FROM tg_customer_type WHERE id = ?";
        var filter = [postData.cust_type_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0].name;
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.addLeadData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            cust_type: postData.cust_type ? postData.cust_type : '',
            cust_type_id: postData.cust_type_id ? postData.cust_type_id : 0,
            company_name: postData.company_name ? postData.company_name : '',
            first_name: postData.first_name ? postData.first_name : '',
            last_name: postData.last_name ? postData.last_name : '',
            site_name: postData.site_name ? postData.site_name : '',
            mobile: postData.mobile ? postData.mobile : null,
            email: postData.email ? postData.email : null,
            whatsapp_no: postData.whatsapp_no ? postData.whatsapp_no : '',
            street: postData.street ? postData.street : '',
            state_name: postData.state_name ? postData.state_name : '',
            district_name: postData.district_name ? postData.district_name : '',
            city: postData.city ? postData.city : '',
            pincode: postData.pincode ? postData.pincode : '',
            status: postData.lead_status?.name ? postData.lead_status.name : 'Pending',
            date_of_birth: postData.date_of_birth ? postData.date_of_birth : '0000-00-00',
            date_of_anniversary: postData.date_of_anniversary ? postData.date_of_anniversary : '0000-00-00',
            is_lead: 0,  // is lead is ZERO now
            registered: 0,
            otp_valid_upto: 60,
            remark: postData.remark ? postData.remark : '',
            stage_remark: postData.stage_remark ? postData.stage_remark : '',
            stage: postData.lead_status?.name ? postData.lead_status.name : 'Pending',
            lead_source: postData.lead_source ? postData.lead_source : '',
            updated_on: nowDateTime,
            created_on: nowDateTime,
            created_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            created_by_type: postData.sfa_app_user_type ? postData.sfa_app_user_type : '',
            created_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
        }


        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_customer set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.updateStageStatus = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            stage: postData.stage ? postData.stage : '',
            stage_remark: postData.stage_remark ? postData.stage_remark : ''
        }

        // console.log('updateDataValues',updateDataValues);

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer", updateDataValues, postData.lead_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


// order module code start


SFA_Master.getOrderDrTypeData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        var queryString = "SELECT tg_customer_type.* FROM tg_customer_type WHERE status  = ? AND for_network = ? " + whereCondition + " ORDER BY ID DESC";
        var filter = [1, 1];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getOrderDataCount = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        if (postData.filter.order_no) {
            whereCondition += " AND (tg_customer_order.order_no LIKE '%" + postData.filter.order_no + "%')";
        }
        if (postData.filter.cust_type) {
            whereCondition += " AND (tg_customer.cust_type LIKE '%" + postData.filter.cust_type + "%')";
        }
        if (postData.filter.dr_data) {
            whereCondition += " AND (tg_customer.company_name LIKE '%" + postData.filter.dr_data + "%' OR tg_customer.mobile LIKE '%" + postData.filter.dr_data + "%' OR  tg_customer.cust_code LIKE '%" + postData.filter.dr_data + "%' OR  tg_customer.email LIKE '%" + postData.filter.dr_data + "%' )";
        }
        if (postData.filter.created_on) {
            whereCondition += " AND (DATE(tg_customer_order.created_on) = '" + postData.filter.created_on + "')";
        }
        if (postData.filter.customer_id) {
            whereCondition += " AND (tg_customer_order.customer_id = '" + postData.filter.customer_id + "')";
        }

        if (postData.filter.order_status != 'All' && postData.filter.order_status != undefined) {
            whereCondition += " AND (tg_customer_order.order_status = '" + postData.filter.order_status + "')";
        }

        if (postData.filter.order_type) {
            whereCondition += " AND (tg_customer_order.order_type = '" + postData.filter.order_type + "')";
        }

        if (postData.filter.created_by_name) {
            whereCondition += " AND (tg_customer_order.created_by_name LIKE '%" + postData.filter.created_by_name + "%')";
        }

        if (postData.sfa_web_user_type == 'dealer') {
            whereCondition += " AND (tg_customer_order.created_by  = '" + postData.sfa_web_user_id + "' )";
        }

        if (postData.filter.date_from && postData.filter.date_to) {
            whereCondition += ' AND ( DATE(tg_customer_order.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }

        if (postData.filter.team == true) {
            whereCondition += " AND (tg_customer_order.created_by IN (" + postData.sfa_app_user_assignedUserIds + "))";
        }

        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT IF(COUNT(tg_customer_order.id),COUNT(tg_customer_order.id),0) as totalCount FROM tg_customer_order LEFT JOIN tg_customer ON tg_customer.id = tg_customer_order.customer_id  WHERE  1 = 1 AND tg_customer_order.del = ? AND tg_customer_order.created_by = ? " + whereCondition;
        var filter = [0, postData.sfa_app_user_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if (res.length) {
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


SFA_Master.getOrderDataList = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        if (postData.filter.order_no) {
            whereCondition += " AND (tg_customer_order.order_no LIKE '%" + postData.filter.order_no + "%')";
        }
        if (postData.filter.cust_type) {
            whereCondition += " AND (tg_customer.cust_type LIKE '%" + postData.filter.cust_type + "%')";
        }
        if (postData.filter.dr_data) {
            whereCondition += " AND (tg_customer.company_name LIKE '%" + postData.filter.dr_data + "%' OR tg_customer.mobile LIKE '%" + postData.filter.dr_data + "%' OR  tg_customer.cust_code LIKE '%" + postData.filter.dr_data + "%' OR  tg_customer.email LIKE '%" + postData.filter.dr_data + "%' )";
        }

        if (postData.filter.created_on) {
            whereCondition += " AND (DATE(tg_customer_order.created_on) = '" + postData.filter.created_on + "')";
        }

        if (postData.filter.order_status != 'All' && postData.filter.order_status != undefined) {
            whereCondition += " AND (tg_customer_order.order_status = '" + postData.filter.order_status + "')";
        }


        if (postData.filter.order_type) {
            whereCondition += " AND (tg_customer_order.order_type = '" + postData.filter.order_type + "')";
        }


        if (postData.filter.customer_id) {
            whereCondition += " AND (tg_customer_order.customer_id = '" + postData.filter.customer_id + "')";
        }
        if (postData.filter.created_by_name) {
            whereCondition += " AND (tg_customer_order.created_by_name LIKE '%" + postData.filter.created_by_name + "%')";
        }
        if (postData.sfa_web_user_type == 'dealer') {
            whereCondition += " AND (tg_customer_order.created_by  = '" + postData.sfa_web_user_id + "' )";
        }

        if (postData.filter.date_from && postData.filter.date_to) {
            whereCondition += ' AND ( DATE(tg_customer_order.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }

        if (postData.filter.team == true) {
            whereCondition += " AND (tg_customer_order.created_by IN (" + postData.sfa_app_user_assignedUserIds + "))";
        }

        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_customer_order.*, tg_customer.company_name, tg_customer.cust_code, tg_customer.email,tg_customer.mobile,tg_customer.landline_no,tg_customer.cust_type FROM tg_customer_order LEFT JOIN tg_customer ON tg_customer.id = tg_customer_order.customer_id  WHERE  1 = 1 AND tg_customer_order.del = ?  AND tg_customer_order.created_by = ? " + whereCondition + " ORDER BY tg_customer_order.id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.sfa_app_user_id, postData.limit, postData.start];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.addOrderData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var nowDate = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        if (postData.delivery_date == undefined) {
            postData.delivery_date = '0000-00-00';
        }

        var insertData = {
            order_type: postData.order_type ? postData.order_type : '',
            customer_id: postData.customer_id ? postData.customer_id : 0,
            customer_name: postData.customer_name ? postData.customer_name : '',
            customer_type: postData.customer_type ? postData.customer_type : '',
            dealer_id: postData.dealer_id ? postData.dealer_id : 0,
            dealer_name: postData.dealer_name ? postData.dealer_name : '',
            dealer_type: postData.dealer_type ? postData.dealer_type : '',
            order_no: postData.order_no ? postData.order_no : null,
            order_date: postData.order_date ? postData.order_date : nowDate,
            delivery_date: postData.delivery_date ? postData.delivery_date : '0000-00-00',
            payment_date: postData.payment_date ? postData.payment_date : '0000-00-00',
            order_status: postData.order_status ? postData.order_status : 'Pending',
            total_item: postData.total_item ? postData.total_item : 0,
            total_qty: postData.total_qty ? postData.total_qty : 0,
            total_amt: postData.total_amt ? postData.total_amt : 0,
            tax_amt: postData.tax_amt ? postData.tax_amt : 0,
            discount_amt: postData.discount_amt ? postData.discount_amt : 0,
            net_amt: postData.net_amt ? postData.net_amt : 0,
            sub_total: postData.sub_total ? postData.sub_total : 0,
            remark: postData.remark ? postData.remark : '',
            del: postData.del ? postData.del : 0,
            checkin_id: postData.checkin_id ? postData.checkin_id : 0,
            created_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            created_by_type: postData.sfa_app_user_type ? postData.sfa_app_user_type : '',
            created_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            updated_on: nowDateTime,
            created_on: nowDateTime
        }

        var queryString = "INSERT INTO tg_customer_order set ?";

        db.query(queryString, insertData, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                if (res.insertId) {
                    var updateOrderNumber = await SFA_Master.updateOrderNumber(res)
                }
                resolve(res);
            }
        });
    });
};



SFA_Master.updateOrderNumber = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            updated_on: nowDateTime,
            order_no: 'ORDER - #' + postData.insertId
        }

        // console.log('updateDataValues',updateDataValues);

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_order", updateDataValues, postData.insertId];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




SFA_Master.addOrderItemData = function (postData) {
    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            order_id: postData.order_id ? postData.order_id : 0,
            customer_id: postData.customer_id ? postData.customer_id : 0,
            product_type: postData.product_type ? postData.product_type : '',
            product_id: postData.product_id ? postData.product_id : 0,
            product_name: postData.product_name ? postData.product_name : '',
            product_code: postData.product_code ? postData.product_code : '',
            product_group: postData.product_group ? postData.product_group : '',
            brand: postData.brand ? postData.brand : '',
            unit: postData.unit ? postData.unit : '',
            sub_brand: postData.sub_brand ? postData.sub_brand : '',
            category: postData.category ? postData.category : '',
            sub_category: postData.sub_category ? postData.sub_category : '',
            thickness: postData.thickness ? postData.thickness : '',
            size: postData.size ? postData.size : '',
            order_qty: postData.order_qty ? postData.order_qty : 0,
            dispatch_qty: postData.dispatch_qty ? postData.dispatch_qty : 0,
            pending_qty: postData.pending_qty ? postData.pending_qty : 0,
            rate: postData.rate ? postData.rate : 0,
            discount_amt: postData.discount_amt ? postData.discount_amt : 0,
            discount: postData.discount ? postData.discount : 0,
            tax: postData.tax ? postData.tax : 0,
            tax_amt: postData.tax_amt ? postData.tax_amt : 0,
            sub_total: postData.sub_total ? postData.sub_total : 0,
            net_amt: postData.net_amt ? postData.net_amt : 0,
            total_amt: postData.total_amt ? postData.total_amt : 0,
            status: postData.status ? postData.status : 1,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }

        var queryString = "INSERT INTO tg_customer_order_item set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getOrderBasicDetail = function (postData) {

    return new Promise(function (resolve, reject) {

        var queryString = "SELECT tg_customer_order.*,tg_customer.cust_type_id, tg_customer.company_name, tg_customer.cust_code, tg_customer.email,tg_customer.mobile,tg_customer.landline_no,tg_customer.cust_type FROM tg_customer_order LEFT JOIN tg_customer ON tg_customer.id = tg_customer_order.customer_id WHERE tg_customer_order.id = ?";
        var filter = [postData.order_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    // res[0].customer_encrypt_id = encrypt(res[0].customer_id.toString());
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getOrderItemDetail = function (postData) {

    return new Promise(function (resolve, reject) {

        var queryString = "SELECT tg_customer_order_item.*, tg_master_product.product_name,tg_master_product.product_code,tg_master_product.product_group, tg_master_product.unit  FROM tg_customer_order_item LEFT JOIN tg_master_product ON tg_master_product.id = tg_customer_order_item.product_id  WHERE tg_customer_order_item.order_id = ?";
        var filter = [postData.order_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.updateOrderItemData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            updated_on: nowDateTime,
            order_qty: postData.order_qty ? postData.order_qty : 0
        }

        // console.log('updateDataValues',updateDataValues);

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_order_item", updateDataValues, postData.item_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.deleteOrderItemData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            updated_on: nowDateTime,
            deleted: 1
        }

        // console.log('updateDataValues',updateDataValues);

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_order_item", updateDataValues, postData.item_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



// order module code end




exports.submitEnquiry = async function (req, res) {

    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }

    try {
        await db.beginTransaction();

        var submitEnquiry = await User.submitEnquiry(req.body);

        var responseData = {
            type: 'submit_enquiry'
        }

        var getResponseMessage = await User.getResponseMessage(responseData);

        if (submitEnquiry.insertId) {
            await db.commit();
            res.status(200).json({
                message: "Enquiry submitted",
                status: "success",
                responseMessage: getResponseMessage
            });
        } else {
            await db.rollback()
            res.status(200).json({
                message: "Enquiry submitted",
                status: "failed",
            });
        }

    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err: err
        });
        return false;
    }
};


SFA_Master.getEnquiryType = function (postData) {

    return new Promise(function (resolve, reject) {

        var queryString = "SELECT id,name FROM tg_master_enquiry_type WHERE status = ? ORDER BY ordering ASC"
        var filter = [1];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.submitEnquiry = function (postData) {
    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            user_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            type: postData.type,
            email: postData.email,
            enquiry: postData.enquiry,
            mobile_no: postData.sfa_app_user_mobile ? postData.sfa_app_user_mobile : '',
            created_on: nowDateTime
        }

        var queryString = "INSERT INTO tg_enquiry set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getResponseMessage = function (postData) {

    return new Promise(function (resolve, reject) {

        var queryString = "SELECT title,message FROM ?? WHERE type = ? AND status = ?"
        var filter = ['tg_response_message', postData.type, 1];
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};



SFA_Master.getPopAndGiftDataCount = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        var queryString = "SELECT  IF(COUNT(tg_master_pop_gift.id),COUNT(tg_master_pop_gift.id),0) as totalCount  FROM ?? WHERE deleted = ?"
        var filter = ['tg_master_pop_gift', 0];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if (res.length) {
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


SFA_Master.getPopAndGiftDataList = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var queryString = "SELECT tg_master_pop_gift.*,  IF(tg_master_pop_gift.filename != '',CONCAT('" + postData.image_app_path + "', tg_master_pop_gift.filename), '') as filename_path FROM tg_master_pop_gift WHERE  1 = 1 AND tg_master_pop_gift.deleted = ?  " + whereCondition + " ORDER BY tg_master_pop_gift.id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.detailPopAndGiftData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var queryString = "SELECT tg_master_pop_gift.*,  IF(tg_master_pop_gift.filename != '',CONCAT('" + postData.image_app_path + "', tg_master_pop_gift.filename), '') as filename_path FROM tg_master_pop_gift WHERE  1 = 1 AND tg_master_pop_gift.deleted = ?  " + whereCondition;
        var filter = [0, postData.pop_gift_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getGiftAssignDataDetail = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var queryString = "SELECT tg_pop_gift_assign.* FROM tg_pop_gift_assign WHERE  tg_pop_gift_assign.deleted = ? AND tg_pop_gift_assign.pop_gift_id = ? AND tg_pop_gift_assign.user_id = ? " + whereCondition + " ORDER BY tg_pop_gift_assign.ID ASC";
        var filter = [0, postData.pop_gift_id, postData.sfa_app_user_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getGiftRequestDataDetail = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var queryString = "SELECT tg_pop_gift_request.* FROM tg_pop_gift_request WHERE  tg_pop_gift_request.deleted = ? AND tg_pop_gift_request.pop_gift_id = ? AND tg_pop_gift_request.user_id = ? " + whereCondition + " ORDER BY tg_pop_gift_request.ID ASC";
        var filter = [0, postData.pop_gift_id, postData.sfa_app_user_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.assignPopAndGiftData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            name: postData.name ? postData.name : '',
            customer_id: postData.customer_id ? postData.customer_id : 0,
            cust_type_id: postData.cust_type_id ? postData.cust_type_id : 0,
            cust_type: postData.cust_type ? postData.cust_type : '',
            pop_gift_id: postData.pop_gift_id ? postData.pop_gift_id : 0,
            item_name: postData.item_name ? postData.item_name : 0,
            qty: postData.qty ? postData.qty : 0,
            description: postData.description ? postData.description : '',
            created_on: nowDateTime,
            created_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            created_by_type: postData.sfa_app_user_type ? postData.sfa_app_user_type : '',
            created_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            updated_on: nowDateTime,
            deleted: 0
        }

        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_pop_gift_assign set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.requestPopAndGiftData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            user_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            pop_gift_id: postData.pop_gift_id ? postData.pop_gift_id : 0,
            item_name: postData.item_name ? postData.item_name : 0,
            qty: postData.qty ? postData.qty : 0,
            description: postData.description ? postData.description : '',
            created_on: nowDateTime,
            created_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            created_by_type: postData.sfa_app_user_type ? postData.sfa_app_user_type : '',
            created_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            updated_on: nowDateTime,
            deleted: 0
        }

        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_pop_gift_request set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.assignPopAndGiftData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            name: postData.name ? postData.name : '',
            customer_id: postData.customer_id ? postData.customer_id : 0,
            cust_type_id: postData.cust_type_id ? postData.cust_type_id : 0,
            cust_type: postData.cust_type ? postData.cust_type : '',
            pop_gift_id: postData.pop_gift_id ? postData.pop_gift_id : 0,
            item_name: postData.item_name ? postData.item_name : 0,
            qty: postData.qty ? postData.qty : 0,
            description: postData.description ? postData.description : '',
            created_on: nowDateTime,
            created_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            created_by_type: postData.sfa_app_user_type ? postData.sfa_app_user_type : '',
            created_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            updated_on: nowDateTime,
            deleted: 0
        }

        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_pop_gift_assign set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.addEventPlanData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            customer_id: postData.customer_id ? postData.customer_id : 0,
            cust_type_id: postData.cust_type_id ? postData.cust_type_id : 0,
            cust_type: postData.cust_type ? postData.cust_type : '',
            event_date: postData.event_date ? postData.event_date : '0000-00-00',
            total_member: postData.total_member ? postData.total_member : 0,
            total_budget: postData.total_budget ? postData.total_budget : 0,
            status: postData.status ? postData.status : 'Pending',
            description: postData.description ? postData.description : '',
            created_on: nowDateTime,
            created_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            created_by_type: postData.sfa_app_user_type ? postData.sfa_app_user_type : '',
            created_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            updated_on: nowDateTime,
            deleted: 0
        }

        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_event_plan set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




SFA_Master.getEventPlanDataCount = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        if (postData.filter.status != 'All' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_event_plan.status = '" + postData.filter.status + "')";
        }

        var queryString = "SELECT  IF(COUNT(tg_event_plan.id),COUNT(tg_event_plan.id),0) as totalCount  FROM ?? WHERE deleted = ? AND tg_event_plan.user_id  = ? " + whereCondition;
        var filter = ['tg_event_plan', 0, postData.sfa_app_user_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if (res.length) {
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


SFA_Master.getEventPlanDataList = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';

        if (postData.filter.status != 'All' && postData.filter.status != undefined) {
            whereCondition += " AND (tg_event_plan.status = '" + postData.filter.status + "')";
        }


        var queryString = "SELECT tg_event_plan.*, tg_customer.first_name,tg_customer.last_name, tg_customer.company_name, tg_customer.mobile as mobile_no FROM tg_event_plan LEFT JOIN tg_customer ON tg_customer.id = tg_event_plan.customer_id  WHERE  1 = 1 AND tg_event_plan.deleted = ? AND tg_event_plan.user_id  = ?  " + whereCondition + " ORDER BY tg_event_plan.id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.sfa_app_user_id, postData.limit, postData.start];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.deleteEventPlanData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            updated_on: nowDateTime,
            deleted: 1
        }

        // console.log('updateDataValues',updateDataValues);

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_event_plan", updateDataValues, postData.event_plan_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.detailEventPlanData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var queryString = "SELECT tg_event_plan.*,tg_customer.first_name,tg_customer.last_name, tg_customer.company_name,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.mobile as mobile_no FROM tg_event_plan LEFT JOIN tg_customer ON tg_customer.id = tg_event_plan.customer_id WHERE  tg_event_plan.deleted = ?  AND tg_event_plan.id  = ? " + whereCondition + " ORDER BY tg_event_plan.ID DESC";
        var filter = [0, postData.event_plan_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if (res.length) {
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.detailEventPlanParticipantData = function (postData) {

    return new Promise(function (resolve, reject) {

        var whereCondition = '';
        var queryString = "SELECT tg_event_plan_participant.*, IF(tg_event_plan_participant.filename != '',CONCAT('" + postData.image_app_path + "', tg_event_plan_participant.filename), '') as filename_path  FROM tg_event_plan_participant WHERE  tg_event_plan_participant.deleted = ? AND tg_event_plan_participant.event_plan_id = ? AND tg_event_plan_participant.type = ?  " + whereCondition + " ORDER BY tg_event_plan_participant.ID ASC";
        var filter = [0, postData.event_plan_id, postData.type];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.updateEventPlanStatus = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            updated_on: nowDateTime,
            status: postData.status ? postData.status : 'Pending',
            status_remark: postData.status_remark ? postData.status_remark : '',
        }

        // console.log('updateDataValues',updateDataValues);

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_event_plan", updateDataValues, postData.event_plan_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.addEventPlanParticipantData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            event_plan_id: postData.event_plan_id ? postData.event_plan_id : 0,
            type: postData.type ? postData.type : '',
            name: postData.name ? postData.name : '',
            mobile_no: postData.mobile_no ? postData.mobile_no : null,
            filename: postData.filename ? postData.filename : null,
            created_on: nowDateTime,
            created_by: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            created_by_type: postData.sfa_app_user_type ? postData.sfa_app_user_type : '',
            created_by_name: postData.sfa_app_user_name ? postData.sfa_app_user_name : '',
            updated_on: nowDateTime,
            deleted: 0
        }

        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_event_plan_participant set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.deleteEventPlanParticipantData = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            updated_on: nowDateTime,
            deleted: 1
        }

        // console.log('updateDataValues',updateDataValues);

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_event_plan_participant", updateDataValues, postData.participant_id];

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getBlockedThirdPartyApps = function (postData) {

    return new Promise(function (resolve, reject) {

        var queryString = "SELECT tg_master_blocked_apps.* FROM tg_master_blocked_apps WHERE  tg_master_blocked_apps.status = ?";
        var filter = [1];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.thirdPartyAppUsed = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            user_id: postData.user_id ? postData.user_id : 0,
            app_name: postData.app_name ? postData.app_name : '',
            app_package_name: postData.app_package_name ? postData.app_package_name : '',
            created_on: nowDateTime,
        }

        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_system_users_app_used set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




SFA_Master.updateUserLastLatLng = function (postData) {

    return new Promise(function (resolve, reject) {

        return resolve(true);

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var updateDataValues = {
            last_lat: postData.last_lat ? postData.last_lat : postData.start_lat,
            last_lng: postData.last_lng ? postData.last_lng : postData.last_lng,
            last_address: postData.last_address ? postData.last_address : postData.last_address,
            updated_on: nowDateTime,
        }

        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_system_users", updateDataValues, postData.user_id];

        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {

                // var insertUserLocation = await SFA_Master.insertUserLocation(postData);
                // console.log('insertUserLocation',insertUserLocation);

                resolve(res);
            }
        });
    });
};



SFA_Master.insertUserLocation = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            user_id: postData.user_id ? postData.user_id : 0,
            lat: postData.last_lat ? postData.last_lat : '',
            lng: postData.last_lng ? postData.last_lng : '',
            address: postData.last_address ? postData.last_address : '',
            created_on: nowDateTime,
        }

        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_system_users_location set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.trackUserLocation = function (postData) {

    return new Promise(function (resolve, reject) {

        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var insertData = {
            user_id: postData.sfa_app_user_id ? postData.sfa_app_user_id : 0,
            lat: postData.lat ? postData.lat : '',
            lng: postData.lng ? postData.lng : '',
            address: postData.address ? postData.address : '',
            track_type: postData.track_type ? postData.track_type : '',
            attendance_id: postData.attendance_id ? postData.attendance_id : 0,
            checkin_id: postData.checkin_id ? postData.checkin_id : 0,
            created_on: nowDateTime,
        }

        // console.log('insertData',insertData);

        var queryString = "INSERT INTO tg_system_users_location set ?";

        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getAssignedUserList = function (postData) {

    return new Promise(function (resolve, reject) {

        var queryString = "SELECT tg_system_users.id as user_id, tg_system_users.name as assigned_user_name, tg_system_users.designation,tg_system_users.mobile_no, tg_system_users.emp_code FROM  tg_system_user_assign  RIGHT JOIN tg_system_users ON tg_system_users.id = tg_system_user_assign.user_id WHERE  tg_system_user_assign.assigned_user_id = ? AND tg_system_user_assign.deleted = ? GROUP BY tg_system_users.id ORDER BY tg_system_user_assign.id ASC";
        var filter = [postData.sfa_app_user_id, 0];

        console.log('queryString', queryString);
        console.log('filter', filter);

        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


module.exports = SFA_Master;

