var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');


var SFA_Master = function (data) {
    
};

SFA_Master.getTotalSalesExecutiveUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';  
        var queryString = "SELECT IF(COUNT(tg_system_users.id),COUNT(tg_system_users.id),0) as totalCount FROM tg_system_users  LEFT JOIN tg_master_role ON tg_master_role.id = tg_system_users.role WHERE  tg_system_users.deleted = ? AND tg_system_users.status = ? AND 1 = 1 AND tg_master_role.for_sales_user = ? "+ whereCondition
        var filter = [0, 1, 1];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getAttendanceTodayDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        whereCondition += " AND (tg_attendance.attend_date = '"+moment(new Date()).format('YYYY-MM-DD')+"')"; 
        
        var queryString = "SELECT IF(COUNT(tg_attendance.id),COUNT(tg_attendance.id),0) as totalCount FROM tg_attendance  WHERE  1 = 1 AND tg_attendance.deleted = ? "+ whereCondition
        var filter = [0];
        
        // console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getAttendanceDataDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        var queryString = "SELECT tg_attendance.*,   IF(tg_attendance.filename != '',CONCAT('"+postData.image_app_path+"', tg_attendance.filename), '') as filename_path ,  IF(tg_attendance.filename_stop != '',CONCAT('"+postData.image_app_path+"', tg_attendance.filename_stop), '') as filename_stop_path, tg_system_users.name as user_name,tg_system_users.mobile_no,tg_system_users.emp_code, tg_system_user_assign.assigned_user_name as reporting_manager FROM tg_attendance LEFT JOIN  tg_system_users ON tg_system_users.id = tg_attendance.user_id LEFT JOIN  tg_system_user_assign ON tg_system_user_assign.user_id = tg_attendance.user_id  WHERE  tg_attendance.deleted = ? AND tg_attendance.id  = ?";
        var filter = [0, postData.attendance_id];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log('res',res);
                var data = {};
                if(res.length){
                    data = res[0];
                    data.message = data.stop_time != null ? 'Attendance already Stopped for the day' : 'Attendance already punched';
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getAttendanceDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_attendance.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.user_name){
            whereCondition += " AND (tg_attendance.user_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.attend_date){
            whereCondition += " AND (tg_attendance.attend_date = '"+postData.filter.attend_date+"')"; 
        }
        
        if(postData.filter.attend_month){
            whereCondition += " AND (MONTH(tg_attendance.attend_date) = '"+postData.filter.attend_month+"')"; 
        }
        
        if(postData.filter.attend_year){
            whereCondition += " AND (YEAR(tg_attendance.attend_date) = '"+postData.filter.attend_year+"')"; 
        }
        
        
        if(postData.filter.user_id){
            whereCondition += " AND (tg_attendance.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_attendance.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        
        var queryString = "SELECT IF(COUNT(tg_attendance.id),COUNT(tg_attendance.id),0) as totalCount FROM tg_attendance  WHERE  1 = 1 AND tg_attendance.deleted = ? "+ whereCondition
        var filter = [0];
        // console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};



SFA_Master.getAttendanceUserDataListCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_attendance.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        if(postData.filter.user_name){
            whereCondition += " AND (tg_attendance.user_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.attend_date){
            whereCondition += " AND (tg_attendance.attend_date = '"+postData.filter.attend_date+"')"; 
        }
        
        if(postData.filter.attend_month){
            whereCondition += " AND (MONTH(tg_attendance.attend_date) = '"+postData.filter.attend_month+"')"; 
        }
        
        if(postData.filter.attend_year){
            whereCondition += " AND (YEAR(tg_attendance.attend_date) = '"+postData.filter.attend_year+"')"; 
        }
        
        
        if(postData.filter.user_id){
            whereCondition += " AND (tg_attendance.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_attendance.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        var queryString = "SELECT IF(COUNT(tg_attendance.id),COUNT(tg_attendance.id),0) as totalCount FROM tg_attendance LEFT JOIN  tg_system_users ON tg_system_users.id = tg_attendance.user_id   WHERE  1 = 1 AND tg_attendance.deleted = ? "+ whereCondition +" ORDER BY tg_attendance.id DESC";
        var filter = [0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getAttendanceUserDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_attendance.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        if(postData.filter.user_name){
            whereCondition += " AND (tg_attendance.user_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.attend_date){
            whereCondition += " AND (tg_attendance.attend_date = '"+postData.filter.attend_date+"')"; 
        }
        
        if(postData.filter.attend_month){
            whereCondition += " AND (MONTH(tg_attendance.attend_date) = '"+postData.filter.attend_month+"')"; 
        }
        
        if(postData.filter.attend_year){
            whereCondition += " AND (YEAR(tg_attendance.attend_date) = '"+postData.filter.attend_year+"')"; 
        }
        
        
        if(postData.filter.user_id){
            whereCondition += " AND (tg_attendance.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_attendance.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        var queryString = "SELECT tg_attendance.* , IF(tg_attendance.filename != '',CONCAT('"+postData.image_app_path+"', tg_attendance.filename), '') as filename_path ,  IF(tg_attendance.filename_stop != '',CONCAT('"+postData.image_app_path+"', tg_attendance.filename_stop), '') as filename_stop_path, tg_system_users.name as user_name,tg_system_users.mobile_no, tg_system_users.emp_code, tg_system_users.designation FROM tg_attendance LEFT JOIN  tg_system_users ON tg_system_users.id = tg_attendance.user_id   WHERE  1 = 1 AND tg_attendance.deleted = ? "+ whereCondition +" ORDER BY tg_attendance.id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async x => {
                        x.user_encrypt_id = encrypt(x.user_id.toString());
                        x.attendance_encrypt_id = encrypt(x.id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
                
            }
        });
    });
};


SFA_Master.getAttendanceDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_attendance.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        if(postData.filter.user_name){
            whereCondition += " AND (tg_attendance.user_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.attend_date){
            whereCondition += " AND (tg_attendance.attend_date = '"+postData.filter.attend_date+"')"; 
        }
        
        if(postData.filter.attend_month){
            whereCondition += " AND (MONTH(tg_attendance.attend_date) = '"+postData.filter.attend_month+"')"; 
        }
        
        if(postData.filter.attend_year){
            whereCondition += " AND (YEAR(tg_attendance.attend_date) = '"+postData.filter.attend_year+"')"; 
        }
        
        
        if(postData.filter.user_id){
            whereCondition += " AND (tg_attendance.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_attendance.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        var queryString = "SELECT tg_attendance.* , IF(tg_attendance.filename != '',CONCAT('"+postData.image_app_path+"', tg_attendance.filename), '') as filename_path ,  IF(tg_attendance.filename_stop != '',CONCAT('"+postData.image_app_path+"', tg_attendance.filename_stop), '') as filename_stop_path, tg_system_users.name as user_name,tg_system_users.mobile_no, tg_system_users.emp_code, tg_system_users.designation FROM tg_attendance LEFT JOIN  tg_system_users ON tg_system_users.id = tg_attendance.user_id   WHERE  1 = 1 AND tg_attendance.deleted = ? "+ whereCondition +" ORDER BY tg_attendance.id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async x => {
                        x.user_encrypt_id = encrypt(x.user_id.toString());
                        x.attendance_encrypt_id = encrypt(x.id.toString());
                        // var getCheckinDataCount = await SFA_Master.getCheckinDataCount({filter : {
                        //     user_id : x.user_id,
                        //     checkin_date : x.attend_date
                        // }});
                        // // console.log('getCheckinDataCount',getCheckinDataCount);
                        // x.checkin_count = getCheckinDataCount;
                        
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
                
            }
        });
    });
};



SFA_Master.getAttendanceMonthDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_attendance.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        if(postData.filter.user_name){
            whereCondition += " AND (tg_attendance.user_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.attend_date){
            whereCondition += " AND (tg_attendance.attend_date LIKE '%"+postData.filter.attend_date+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_attendance.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        var queryString = "SELECT tg_attendance.user_id, tg_system_users.name as user_name,tg_system_users.mobile_no, tg_system_users.emp_code, tg_system_users.designation , IF(tg_attendance.filename != '',CONCAT('"+postData.image_app_path+"', tg_attendance.filename), '') as filename_path ,  IF(tg_attendance.filename_stop != '',CONCAT('"+postData.image_app_path+"', tg_attendance.filename_stop), '') as filename_stop_path FROM tg_attendance LEFT JOIN  tg_system_users ON tg_system_users.id = tg_attendance.user_id   WHERE  1 = 1 "+ whereCondition +" GROUP BY tg_attendance.user_id LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async x => {
                        x.user_encrypt_id = encrypt(x.user_id.toString());
                        x.monthDetail = [];
                        
                        for (const element of postData.monthDateArray) {
                            
                            x.total_absent_days = 25;
                            x.total_leave_days = 0;
                            x.total_working_days = 28;
                            x.month = moment(element).format('MM');
                            x.month_name = moment(element).format('MMM');
                            x.year = moment(element).format('YYYY');
                            
                            var getWeeklyOffDay = await SFA_Master.getUserWeeklyOffDay({'user_id' : x.user_id});
                            // console.log('getWeeklyOffDay',getWeeklyOffDay);
                            
                            if(element <= moment(new Date()).format('YYYY-MM-DD')){
                                
                                var getAttendanceCountData = await SFA_Master.getAttendanceDataCount({'limit' :10, 'start' : 0 ,'filter' : {'attend_month' : moment(element).format('YYYY'),'attend_month' : moment(element).format('MM'), 'user_id' : x.user_id}});
                                
                                console.log('getAttendanceCountData',getAttendanceCountData);
                                
                                x.total_present_days = getAttendanceCountData;
                                
                                var getAttendanceData = await SFA_Master.getAttendanceDataList({'limit' :10, 'start' : 0 ,'filter' : {'attend_date' : element, 'user_id' : x.user_id}});
                                
                                console.log('getAttendanceData',getAttendanceData, i);
                                getAttendanceData = getAttendanceData.length ? getAttendanceData[0] : {};
                                
                                var attend_type = moment(element).format('dddd') != getWeeklyOffDay ? getAttendanceData.id ? 'Present' : 'Absent' : 'Weekly Off';
                            }else{
                                var attend_type = moment(element).format('dddd') != getWeeklyOffDay ? '-' : 'Weekly Off';
                            }
                            
                            var attendData = {
                                "date": element,
                                "day": moment(element).format('dddd'),
                                "attend_type": attend_type,
                                "total_time": getAttendanceData.total_time ? getAttendanceData.total_time : '-'
                            }
                            
                            x.monthDetail.push(attendData);
                        }
                        
                        console.log('i',i);
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
                
            }
        });
    });
};


SFA_Master.getUserWeeklyOffDay = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT weekely_off FROM tg_system_users WHERE  id = ? "+ whereCondition
        var filter = [postData.user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].weekely_off ? res[0].weekely_off : 'Sunday';
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getCheckinDataCountByCustType = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_checkin.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        if(postData.filter.user_name){
            whereCondition += " AND (tg_checkin.created_by_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_checkin.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_checkin.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        
        if(postData.filter.checkin_date){
            whereCondition += " AND (tg_checkin.checkin_date = '"+postData.filter.checkin_date+"')"; 
        }
        
        if(postData.filter.user_id){
            whereCondition += " AND (tg_checkin.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount, cust_type FROM tg_checkin WHERE  1 = 1 "+ whereCondition + " GROUP BY cust_type"
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getCheckinDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_checkin.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        if(postData.filter.user_name){
            whereCondition += " AND (tg_checkin.created_by_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.checkin_date){
            whereCondition += " AND ((tg_checkin.checkin_date) = '"+moment(new Date(postData.filter.checkin_date)).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_checkin.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_checkin.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        
        if(postData.filter.user_id){
            whereCondition += " AND (tg_checkin.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_checkin WHERE  1 = 1 "+ whereCondition
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getCheckinDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        var orderByCondition = '';
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_checkin.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        if(postData.filter.user_name){
            whereCondition += " AND (tg_checkin.created_by_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.checkin_date){
            whereCondition += " AND ((tg_checkin.checkin_date) = '"+moment(new Date(postData.filter.checkin_date)).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_checkin.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.company_name){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.company_name+"%')"; 
        }
        
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_checkin.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        if(postData.filter.user_id){
            whereCondition += " AND (tg_checkin.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        if(postData.filter.order_by == 'ASC'){
            orderByCondition += ' ORDER BY tg_checkin.ID ASC'
        }else{
            orderByCondition += ' ORDER BY tg_checkin.ID DESC'
        }
        
        var queryString = "SELECT tg_checkin.*, tg_system_users.name as user_name,tg_system_users.mobile_no,tg_system_users.emp_code, tg_customer.company_name,tg_customer.first_name as cust_first_name,tg_customer.last_name as cust_last_name , tg_system_user_assign.assigned_user_name as reporting_manager,  IF(tg_checkin.doc_filename != '',CONCAT('"+postData.image_app_path+"', tg_checkin.doc_filename), '') as doc_filename_path FROM tg_checkin  LEFT JOIN  tg_system_users ON tg_system_users.id = tg_checkin.user_id  LEFT JOIN  tg_system_user_assign ON tg_system_user_assign.user_id = tg_checkin.user_id  LEFT JOIN  tg_customer ON tg_customer.id = tg_checkin.customer_id  WHERE  1 = 1 "+ whereCondition +" GROUP BY tg_checkin.id "+ orderByCondition +" LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('postData',postData);
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter,async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async x => {
                        x.user_encrypt_id = encrypt(x.user_id.toString());
                        x.customer_encrypt_id = encrypt(x.customer_id.toString());
                        x.order_encrypt_id = x.order_id ?  encrypt(x.order_id.toString()) : '';
                        x.followup_encrypt_id = x.followup_id ?  encrypt(x.followup_id.toString()) : '';
                        x.image_app_path = postData.image_app_path;
                        var getCheckinDocument = await SFA_Master.getCheckinDocument(x);
                        console.log('getCheckinDocument',getCheckinDocument);
                        x.checkin_document = getCheckinDocument.length ? getCheckinDocument : [];
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
                
            }
        });
    });
};

SFA_Master.getCheckinDocument = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';        
        var queryString = "SELECT IF(tg_checkin_document.doc_filename != '',CONCAT('"+postData.image_app_path+"', tg_checkin_document.doc_filename), '') as doc_filename_path FROM tg_checkin_document WHERE deleted = ? AND checkin_id = ?";
        var filter = [0, postData.id];
        
        // console.log('postData',postData);
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {                
                resolve(res);
            }
        });
    });
};


SFA_Master.getLeaveDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';        
        
        if(postData.filter.status != 'All' && postData.filter.status != undefined){
            whereCondition += " AND (tg_leave.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_leave.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.start_date){
            whereCondition += " AND (DATE(tg_leave.start_date) = '"+moment(postData.filter.start_date).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.end_date){
            whereCondition += " AND (DATE(tg_leave.end_date) = '"+moment(postData.filter.end_date).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.user_name){
            whereCondition += " AND (tg_leave.created_by_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_leave.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.user_id){
            whereCondition += " AND (tg_leave.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        // if(postData.filter.company_name){
        //     whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.company_name+"%')"; 
        // }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_leave WHERE  1 = 1 "+ whereCondition
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getLeaveDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.status != 'All' && postData.filter.status != undefined){
            whereCondition += " AND (tg_leave.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_leave.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.start_date){
            whereCondition += " AND (DATE(tg_leave.start_date) = '"+moment(postData.filter.start_date).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.end_date){
            whereCondition += " AND (DATE(tg_leave.end_date) = '"+moment(postData.filter.end_date).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.user_name){
            whereCondition += " AND (tg_leave.created_by_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_leave.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.user_id){
            whereCondition += " AND (tg_leave.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        var queryString = "SELECT tg_leave.*, tg_system_users.name as user_name,tg_system_users.mobile_no ,tg_system_users.designation   FROM tg_leave  LEFT JOIN  tg_system_users ON tg_system_users.id = tg_leave.user_id WHERE  1 = 1 "+ whereCondition +" ORDER BY tg_leave.id DESC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.user_encrypt_id = encrypt(x.user_id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
                
            }
        });
    });
};


SFA_Master.updateLeaveStatus = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status_remark : postData.remark ? postData.remark : '',
            status_on : nowDateTime ? nowDateTime : '',
            status_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : '',
            status_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            status : postData.status ? postData.status : '',
            updated_on : nowDateTime ? nowDateTime : '',
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_leave", updateDataValues, postData.leave_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getLeaveDataDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = ''; 
        var queryString = "SELECT tg_leave.*, tg_system_users.name as user_name,tg_system_users.mobile_no ,tg_system_users.designation   FROM tg_leave  LEFT JOIN  tg_system_users ON tg_system_users.id = tg_leave.user_id WHERE  1 = 1 "+ whereCondition +" AND  tg_leave.id = ? ";
        var filter = [postData.leave_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};



SFA_Master.getTravelPlanTypeData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_master_travel_plan_type.* FROM tg_master_travel_plan_type WHERE status  = ? "+whereCondition+" ORDER BY ID DESC";
        var filter = [1];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

SFA_Master.addTravelPlanData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var insertData = {
            user_id : postData.sales_user.id ? postData.sales_user.id : 0,
            customer_id : postData.customer_id ? postData.customer_id : 0,
            cust_type_id : postData.cust_type_id ? postData.cust_type_id : 0,
            cust_type : postData.cust_type ? postData.cust_type : '',
            description : postData.description ? postData.description : '',
            travel_from : postData.travel_from ? postData.travel_from : '0000-00-00',
            travel_to : postData.travel_to ? postData.travel_to : '0000-00-00',
            travel_type : postData.travel_type ? postData.travel_type : '',
            total_days : postData.total_days ? postData.total_days : 0,
            state_name : postData.state_name ? postData.state_name : '',
            district_name : postData.district_name ? postData.district_name : '',
            city : postData.city ? postData.city : '',
            area : postData.area ? postData.area : '',
            status : postData.status ? postData.status : 'Pending',
            created_on:nowDateTime,
            created_by:postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            created_by_type:postData.sfa_web_user_type ? postData.sfa_web_user_type : '',
            created_by_name:postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on:nowDateTime,
            deleted: 0
        }
        
        // console.log('insertData',insertData);
        
        var queryString = "INSERT INTO tg_travel_plan set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getTravelPlanDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';  
        
        if(postData.filter.status != 'All' && postData.filter.status != undefined){
            whereCondition += " AND (tg_travel_plan.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.user_id){
            whereCondition += " AND (tg_travel_plan.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_travel_plan.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_travel_plan WHERE  1 = 1 "+ whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getTravelPlanDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.status != 'All' && postData.filter.status != undefined){
            whereCondition += " AND (tg_travel_plan.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.user_id){
            whereCondition += " AND (tg_travel_plan.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_travel_plan.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        
        var queryString = "SELECT tg_travel_plan.*, tg_customer.first_name,tg_customer.last_name, tg_customer.company_name,tg_customer.street,tg_customer.state_name,tg_customer.district_name, tg_system_users.name as user_name,tg_system_users.mobile_no, tg_system_users.designation  FROM tg_travel_plan  LEFT JOIN tg_customer ON tg_customer.id = tg_travel_plan.customer_id   LEFT JOIN  tg_system_users ON tg_system_users.id = tg_travel_plan.user_id WHERE  1 = 1 "+ whereCondition +" ORDER BY tg_travel_plan.id DESC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        x.user_encrypt_id = encrypt(x.user_id.toString());
                        x.cust_encrypt_id = encrypt(x.customer_id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
                
            }
        });
    });
};


SFA_Master.updateTravelPlanStatus = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status_remark : postData.remark ? postData.remark : '',
            status_on : nowDateTime ? nowDateTime : '',
            status_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : '',
            status_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            status : postData.status ? postData.status : '',
            updated_on : nowDateTime ? nowDateTime : '',
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_travel_plan", updateDataValues, postData.travel_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.detailTravelPlanData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_travel_plan.*,tg_customer.first_name,tg_customer.last_name, tg_customer.company_name,tg_system_users.designation FROM tg_travel_plan LEFT JOIN tg_customer ON tg_customer.id = tg_travel_plan.customer_id  LEFT JOIN tg_system_users ON tg_system_users.id = tg_travel_plan.user_id WHERE  tg_travel_plan.deleted = ?  AND tg_travel_plan.id  = ?";
        var filter = [0, postData.travel_plan_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};




SFA_Master.getCustomerNetworkTypeList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id,name,slug FROM tg_customer_type WHERE  status = ? ";
        var filter = [1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {   
                resolve(res);        
            }
        });
    });
};



SFA_Master.getDistributorNetworkCount = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (company_name LIKE '%"+postData.filter.search+"%'  OR cust_code LIKE '%"+postData.filter.search+"%' OR mobile LIKE '%"+postData.filter.search+"%' )"; 
        }
        
        if(postData.filter.cust_type_id){
            whereCondition += " AND (cust_type_id = '"+postData.filter.cust_type_id+"')"; 
        }
        
        if(postData.filter.branch){
            whereCondition += " AND (branch = '"+postData.filter.branch+"')"; 
        }
        
        if(postData.filter.is_lead){
            whereCondition += " AND (is_lead = '"+postData.filter.is_lead+"')"; 
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_customer WHERE deleted = ? AND 1 = 1 "+ whereCondition
        var filter = [0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getDistributorNetworkList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (company_name LIKE '%"+postData.filter.search+"%'  OR cust_code LIKE '%"+postData.filter.search+"%' OR mobile LIKE '%"+postData.filter.search+"%' )"; 
        }
        
        if(postData.filter.cust_type_id){
            whereCondition += " AND (cust_type_id = '"+postData.filter.cust_type_id+"')"; 
        }
        
        if(postData.filter.branch){
            whereCondition += " AND (branch = '"+postData.filter.branch+"')"; 
        }
        
        if(postData.filter.is_lead){
            whereCondition += " AND (is_lead = '"+postData.filter.is_lead+"')"; 
        }
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT id,company_name,cust_code,cust_type,mobile, street, state_name, district_name,city,area,branch,pincode  FROM tg_customer WHERE deleted = ? AND 1 = 1 "+ whereCondition +" ORDER BY id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




SFA_Master.getSalesUserCount = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        
        if(postData.filter.role){
            whereCondition += " AND (tg_system_users.role = '"+postData.filter.role+"')"; 
        }
        
        if(postData.filter.for_sales_user){
            whereCondition += " AND (tg_master_role.for_sales_user = '"+postData.filter.for_sales_user+"')"; 
        }
        
        
        var queryString = "SELECT IF(COUNT(tg_system_users.id),COUNT(tg_system_users.id),0) as totalCount FROM tg_system_users LEFT JOIN tg_master_role ON tg_master_role.id = tg_system_users.role  WHERE tg_system_users.deleted = ? AND tg_system_users.status = ? AND 1 = 1 "+ whereCondition
        var filter = [0, 1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getSalesUserList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.role){
            whereCondition += " AND (tg_system_users.role = '"+postData.filter.role+"')"; 
        }
        
        if(postData.filter.for_sales_user){
            whereCondition += " AND (tg_master_role.for_sales_user = '"+postData.filter.for_sales_user+"')"; 
        }
        
        
        var queryString = "SELECT tg_system_users.id,tg_system_users.name,tg_system_users.mobile_no,tg_system_users.email,tg_system_users.emp_code,tg_system_users.designation  FROM tg_system_users LEFT JOIN tg_master_role ON tg_master_role.id = tg_system_users.role  WHERE tg_system_users.deleted = ? AND tg_system_users.status = ? AND 1 = 1 "+ whereCondition +" ORDER BY id DESC LIMIT ? OFFSET ? ";
        var filter = [0,1, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




SFA_Master.getFollowupDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';  
        var nowDate = moment(new Date()).format('YYYY-MM-DD');
        
        if(postData.filter.status != 'All' && postData.filter.status != undefined){
            whereCondition += " AND (tg_followup.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.followup_type == 'Today'){
            whereCondition += " AND (DATE(tg_followup.followup_date) = '"+nowDate+"')"; 
        }
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_followup.created_on) = '"+moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.followup_date){
            whereCondition += " AND (DATE(tg_followup.followup_date) = '"+moment(new Date(postData.filter.followup_date)).format('YYYY-MM-DD')+"')"; 
        }
        
        
        if(postData.filter.followup_type == 'Upcoming'){
            whereCondition += " AND (DATE(tg_followup.followup_date) > '"+nowDate+"')"; 
        }
        
        
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_followup.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        
        if(postData.filter.user_id){
            whereCondition += " AND (tg_followup.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_followup WHERE  1 = 1 AND deleted = ? "+ whereCondition
        var filter = [0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.getFollowupDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        var nowDate = moment(new Date()).format('YYYY-MM-DD');
        
        if(postData.filter.status != 'All' && postData.filter.status != undefined){
            whereCondition += " AND (tg_followup.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.followup_type == 'Today'){
            whereCondition += " AND (DATE(tg_followup.followup_date) = '"+nowDate+"')"; 
        }
        
        if(postData.filter.followup_date){
            whereCondition += " AND (DATE(tg_followup.followup_date) = '"+moment(new Date(postData.filter.followup_date)).format('YYYY-MM-DD')+"')"; 
        }
        
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_followup.created_on) = '"+moment(new Date(postData.filter.created_on)).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.followup_type == 'Upcoming'){
            whereCondition += " AND (DATE(tg_followup.followup_date) > '"+nowDate+"')"; 
        }
        
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_followup.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        
        if(postData.filter.user_id){
            whereCondition += " AND (tg_followup.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        var queryString = "SELECT tg_followup.*, tg_system_users.name as user_name,tg_system_users.mobile_no , tg_customer.first_name,tg_customer.last_name, tg_customer.company_name,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.mobile as cust_mobile FROM tg_followup  LEFT JOIN  tg_system_users ON tg_system_users.id = tg_followup.user_id  LEFT JOIN tg_customer ON tg_customer.id = tg_followup.customer_id  WHERE  1 = 1 AND tg_followup.deleted = ? "+ whereCondition +" ORDER BY tg_followup.id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.user_encrypt_id = encrypt(x.user_id.toString());
                        x.customer_encrypt_id = encrypt(x.customer_id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
                
            }
        });
    });
};


SFA_Master.addFollowUpData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var insertData = {
            user_id : postData.sales_user.id ? postData.sales_user.id : 0,
            customer_id : postData.dr_id.id ? postData.dr_id.id : 0,
            cust_type_id : postData.dr_type.id ? postData.dr_type.id : 0,
            cust_type : postData.dr_id.cust_type ? postData.dr_id.cust_type : '',
            status : postData.status ? postData.status : 'Pending',
            description : postData.description ? postData.description : '',
            followup_date_time :  postData.followup_date ? moment(postData.followup_date).format('YYYY-MM-DD HH:mm:ss') : '0000-00-00 00:00:00',
            followup_date : postData.followup_date ? moment(postData.followup_date).format('YYYY-MM-DD') : '0000-00-00',
            followup_time : postData.followup_time ? postData.followup_time : '00:00',
            created_on:nowDateTime,
            created_by:postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            created_by_type:postData.sfa_web_user_type ? postData.sfa_web_user_type : '',
            created_by_name:postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on:nowDateTime,
            deleted: 0
        }
        
        // console.log('insertData',insertData);
        
        var queryString = "INSERT INTO tg_followup set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.updateFollowupData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            user_id : postData.sales_user.id ? postData.sales_user.id : 0,
            customer_id : postData.dr_id.id ? postData.dr_id.id : 0,
            cust_type_id : postData.dr_type.id ? postData.dr_type.id : 0,
            cust_type : postData.dr_id.cust_type ? postData.dr_id.cust_type : '',
            description : postData.description ? postData.description : '',
            followup_date_time :  postData.followup_date ? moment(postData.followup_date).format('YYYY-MM-DD HH:mm:ss') : '0000-00-00 00:00:00',
            followup_date : postData.followup_date ? moment(postData.followup_date).format('YYYY-MM-DD') : '0000-00-00',
            followup_time : postData.followup_time ? postData.followup_time : '00:00',
            updated_on:nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_followup", updateDataValues, postData.followup_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.deleteFollowupData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            updated_on:nowDateTime,
            deleted: 1
        }
        
        // console.log('updateDataValues',updateDataValues);
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_followup", updateDataValues, postData.followup_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




SFA_Master.addExpenseData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            user_id : postData.user_id.id ? postData.user_id.id : 0,
            type : postData.type ? postData.type : '',
            purpose_of_visit : postData.purpose_of_visit ? postData.purpose_of_visit : '',
            advance_amt : postData.advance_amt ? postData.advance_amt : 0,
            food_total : postData.food_total ? postData.food_total : 0,
            hotel_total : postData.hotel_total ? postData.hotel_total : 0,
            local_conveyance_total : postData.local_conveyance_total ? postData.local_conveyance_total : 0,
            travel_entitlement_total : postData.travel_entitlement_total ? postData.travel_entitlement_total : 0,
            misc_total : postData.misc_total ? postData.misc_total : 0,
            total : postData.total ? postData.total : 0,
            status : postData.status ? postData.status : 'Pending',
            remark : postData.remark ? postData.remark : '',
            created_on:nowDateTime,
            created_by:postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            created_by_type:postData.sfa_web_user_type ? postData.sfa_web_user_type : '',
            created_by_name:postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on:nowDateTime,
            deleted: 0
        }
        
        // console.log('insertData',insertData);
        
        var queryString = "INSERT INTO tg_expense set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.addExpenseDetailData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            expense_id : postData.expense_id ? postData.expense_id : 0,
            expense_type : postData.expense_type ? postData.expense_type : '',
            nature_of_expense : postData.nature_of_expense ? postData.nature_of_expense : '',
            date : postData.date ? postData.date : '0000-00-00',
            amount : postData.amount ? postData.amount : 0,
            remark : postData.remark ? postData.remark : '',
            mode_of_travel : postData.mode_of_travel ? postData.mode_of_travel : '',
            city : postData.city ? postData.city : '',
            name : postData.name ? postData.name : '',
            checkin_date : postData.checkin_date ? postData.checkin_date : '0000-00-00',
            checkout_date : postData.checkout_date ? postData.checkout_date : '0000-00-00',
            departure_date_time : postData.departure_date_time ? postData.departure_date_time : '0000-00-00 00:00:00',
            departure_station : postData.departure_station ? postData.departure_station : '',
            arrival_date_time : postData.arrival_date_time ? postData.arrival_date_time : '0000-00-00 00:00:00',
            arrival_station : postData.arrival_station ? postData.arrival_station : '',
            detail_ticket_no : postData.detail_ticket_no ? postData.detail_ticket_no : '',
            travel_distance : postData.travel_distance ? postData.travel_distance : 0,
            created_on:nowDateTime,
            created_by:postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            created_by_type:postData.sfa_web_user_type ? postData.sfa_web_user_type : '',
            created_by_name:postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on:nowDateTime,
            deleted: 0
        }
        
        // console.log('insertData',insertData);
        
        var queryString = "INSERT INTO tg_expense_data set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getExpenseDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.status != 'All' && postData.filter.status != undefined){
            whereCondition += " AND (tg_expense.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_expense.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.user_name){
            whereCondition += " AND (tg_expense.created_by_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_expense.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        if(postData.filter.user_id){
            whereCondition += " AND (tg_expense.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT IF(COUNT(tg_expense.id),COUNT(tg_expense.id),0) as totalCount FROM tg_expense  WHERE  1 = 1 AND tg_expense.deleted = ? "+ whereCondition;
        var filter = [0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if(res.length){
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


SFA_Master.getExpenseDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.status != 'All' && postData.filter.status != undefined){
            whereCondition += " AND (tg_expense.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_expense.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.user_name){
            whereCondition += " AND (tg_expense.created_by_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_expense.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        if(postData.filter.user_id){
            whereCondition += " AND (tg_expense.user_id = '"+postData.filter.user_id+"')"; 
        }
        
        
        var queryString = "SELECT tg_expense.*,tg_system_users.name as user_name , tg_system_users.designation FROM tg_expense LEFT JOIN  tg_system_users ON tg_system_users.id = tg_expense.user_id  WHERE  1 = 1 AND tg_expense.deleted = ?  "+ whereCondition +" ORDER BY tg_expense.id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};



SFA_Master.getExpenseData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_expense.* FROM tg_expense WHERE  1 = 1 AND tg_expense.deleted = ?  AND tg_expense.id = ? "+ whereCondition;
        var filter = [0,postData.expense_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};



SFA_Master.getExpenseDataDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_expense_data.* FROM tg_expense_data WHERE  1 = 1 AND tg_expense_data.deleted = ?  AND tg_expense_data.expense_id = ? "+ whereCondition +" ORDER BY tg_expense_data.id DESC";
        var filter = [0,postData.expense_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.updateExpenseStatus = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status_remark : postData.remark ? postData.remark : '',
            status_on : nowDateTime ? nowDateTime : '',
            status_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : '',
            status_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            status : postData.status ? postData.status : '',
            updated_on : nowDateTime ? nowDateTime : '',
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_expense", updateDataValues, postData.expense_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getEnquiryDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_enquiry.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.user_name){
            whereCondition += " AND (tg_enquiry.user_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_enquiry.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT IF(COUNT(tg_enquiry.id),COUNT(tg_enquiry.id),0) as totalCount FROM tg_enquiry  WHERE  1 = 1 AND tg_enquiry.deleted = ? "+ whereCondition;
        var filter = [0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if(res.length){
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


SFA_Master.getEnquiryDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_enquiry.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.user_name){
            whereCondition += " AND (tg_enquiry.user_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_enquiry.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        
        var queryString = "SELECT tg_enquiry.*,tg_system_users.name as user_name , tg_system_users.designation FROM tg_enquiry LEFT JOIN  tg_system_users ON tg_system_users.id = tg_enquiry.user_id  WHERE  1 = 1 AND tg_enquiry.deleted = ?  "+ whereCondition +" ORDER BY tg_enquiry.id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


SFA_Master.getPopAndGiftIssueTypeData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_master_pop_gift_issue_type.* FROM tg_master_pop_gift_issue_type WHERE status  = ? "+whereCondition+" ORDER BY ID ASC";
        var filter = [1];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getPopAndGiftDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_master_pop_gift.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.user_name){
            whereCondition += " AND (tg_master_pop_gift.user_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_master_pop_gift.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT IF(COUNT(tg_master_pop_gift.id),COUNT(tg_master_pop_gift.id),0) as totalCount FROM tg_master_pop_gift  WHERE  1 = 1 AND tg_master_pop_gift.deleted = ? "+ whereCondition;
        var filter = [0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if(res.length){
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


SFA_Master.getPopAndGiftDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_master_pop_gift.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.filter.user_name){
            whereCondition += " AND (tg_master_pop_gift.user_name LIKE '%"+postData.filter.user_name+"%')"; 
        }
        
        if(postData.filter.date_from && postData.filter.date_to) {
            whereCondition += 'AND ( DATE(tg_master_pop_gift.created_on) BETWEEN  "' + moment(new Date(postData.filter.date_from)).format('YYYY-MM-DD') + '" AND "' + moment(new Date(postData.filter.date_to)).format('YYYY-MM-DD') + '" )';
        }
        
        
        var queryString = "SELECT tg_master_pop_gift.*, IF(tg_master_pop_gift.filename != '',CONCAT('"+postData.image_app_path+"', tg_master_pop_gift.filename), '') as filename_path FROM tg_master_pop_gift  WHERE  1 = 1 AND tg_master_pop_gift.deleted = ?  "+ whereCondition +" ORDER BY tg_master_pop_gift.id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};



SFA_Master.popAndGiftStockLedgerMaintaindata = async function (postData) {
    return new Promise(async function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        var old_stock = 0;
        var new_stock = 0;
        var getOldProductStock = await SFA_Master.getOldPopAndGiftStock(postData);
        console.log('getOldProductStock',getOldProductStock.new_stock);
        var old_stock = getOldProductStock.new_stock == undefined ? 0 : getOldProductStock.new_stock;
        
        if(postData.type == 'stockin' || postData.type == 'stockreverse'){
            new_stock = parseInt(old_stock) + parseInt(postData.stock);
        }else{
            new_stock = parseInt(old_stock) - parseInt(postData.stock);
        }
        
        var insertData = {
            type: postData.type ? postData.type : '',
            pop_gift_id: postData.pop_gift_id ? postData.pop_gift_id : 0,
            gift_assigned_id : postData.gift_assigned_id ? postData.gift_assigned_id : 0,
            old_stock: old_stock ? old_stock : 0,
            stock: postData.stock ? postData.stock : 0,
            new_stock: new_stock ? new_stock : 0,
            remark : postData.remark ? postData.remark : '',
            created_on: nowDateTime
        }
        
        // console.log('insertData',insertData);
        
        var queryString = "INSERT INTO tg_pop_gift_stock_ledger set ?";
        
        db.query(queryString, insertData, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var updatePopAndGiftStock = await SFA_Master.updatePopAndGiftStock(insertData);
                resolve(res);
            }
        });
    });
};



SFA_Master.updatePopAndGiftStock = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            qty : postData.new_stock,
            updated_on: nowDateTime,
        }
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_pop_gift", updateDataValues, postData.pop_gift_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getOldPopAndGiftStock = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT new_stock FROM tg_pop_gift_stock_ledger WHERE  pop_gift_id = ? ORDER BY id DESC LIMIT 1"
        var filter = [postData.pop_gift_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};



SFA_Master.addPopAndGiftData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            item_name:postData.item_name ? postData.item_name : '',
            qty:postData.qty ? postData.qty : 0,
            rate:postData.rate ? postData.rate : 0,
            total_amount:postData.total_amount ? postData.total_amount : 0,
            description:postData.description ? postData.description : '',
            filename:postData.filename ? postData.filename : '',
            created_on:nowDateTime,
            created_by:postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            created_by_type:postData.sfa_web_user_type ? postData.sfa_web_user_type : '',
            created_by_name:postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on:nowDateTime,
            deleted: 0
        }
        
        // console.log('insertData',insertData);
        
        var queryString = "INSERT INTO tg_master_pop_gift set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

SFA_Master.updatePopAndGiftData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            item_name:postData.item_name ? postData.item_name : '',
            rate:postData.rate ? postData.rate : 0,
            total_amount:postData.total_amount ? postData.total_amount : 0,
            description:postData.description ? postData.description : '',
            filename:postData.filename ? postData.filename : '',
            updated_on : nowDateTime ? nowDateTime : '',
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_pop_gift", updateDataValues, postData.pop_gift_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.updatePopAndGiftStockData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            qty :postData.qty ? postData.qty : 0,
            total_amount : postData.total_amount ? postData.total_amount : 0,
            updated_on : nowDateTime ? nowDateTime : '',
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_pop_gift", updateDataValues, postData.pop_gift_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.deletePopAndGiftData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted: 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_master_pop_gift", updateDataValues, postData.pop_gift_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.detailPopAndGiftData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_master_pop_gift.*, IF(tg_master_pop_gift.filename != '',CONCAT('"+postData.image_app_path+"', tg_master_pop_gift.filename), '') as filename_path FROM tg_master_pop_gift WHERE  tg_master_pop_gift.deleted = ?  AND tg_master_pop_gift.id  = ?";
        var filter = [0, postData.pop_gift_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};

SFA_Master.getGiftAssignDataDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        var queryString = "SELECT tg_pop_gift_assign.* FROM tg_pop_gift_assign WHERE  tg_pop_gift_assign.deleted = ? AND tg_pop_gift_assign.pop_gift_id = ? "+whereCondition+" ORDER BY tg_pop_gift_assign.ID DESC";
        var filter = [0, postData.pop_gift_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getGiftStockDataDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        var queryString = "SELECT tg_pop_gift_stock_ledger.* FROM tg_pop_gift_stock_ledger WHERE  tg_pop_gift_stock_ledger.pop_gift_id = ? "+whereCondition+" ORDER BY tg_pop_gift_stock_ledger.ID DESC";
        var filter = [postData.pop_gift_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getGiftRequestDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        var queryString = "SELECT tg_pop_gift_request.* FROM tg_pop_gift_request WHERE  tg_pop_gift_request.pop_gift_id = ? "+whereCondition+" ORDER BY tg_pop_gift_request.ID DESC";
        var filter = [postData.pop_gift_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.assignPopAndGiftData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            user_id : postData.user_id ? postData.user_id : 0,
            type : postData.type ? postData.type : '',
            name : postData.name ? postData.name : '',
            customer_id : postData.customer_id ? postData.customer_id : 0,
            cust_type_id : postData.cust_type_id ? postData.cust_type_id : 0,
            cust_type : postData.cust_type ? postData.cust_type : '',
            pop_gift_id : postData.pop_gift_id ? postData.pop_gift_id : 0,
            item_name : postData.item_name ? postData.item_name : 0,
            qty : postData.input_qty ? postData.input_qty : 0,
            description : postData.description ? postData.description : '',
            created_on:nowDateTime,
            created_by:postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            created_by_type:postData.sfa_web_user_type ? postData.sfa_web_user_type : '',
            created_by_name:postData.sfa_web_user_name ? postData.sfa_web_user_name : '',
            updated_on:nowDateTime,
            deleted: 0
        }
        
        // console.log('insertData',insertData);
        
        var queryString = "INSERT INTO tg_pop_gift_assign set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.getEventPlanDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.status != 'All' && postData.filter.status != undefined){
            whereCondition += " AND (tg_event_plan.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_event_plan.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        var queryString = "SELECT  IF(COUNT(tg_event_plan.id),COUNT(tg_event_plan.id),0) as totalCount  FROM ?? WHERE deleted = ? "+ whereCondition;
        var filter = ['tg_event_plan', 0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if(res.length){
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};


SFA_Master.getEventPlanDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';     
        
        if(postData.filter.status != 'All' && postData.filter.status != undefined){
            whereCondition += " AND (tg_event_plan.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_event_plan.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        var queryString = "SELECT tg_event_plan.*,tg_customer.first_name,tg_customer.last_name, tg_customer.company_name,tg_system_users.designation, tg_system_users.name as user_name, tg_system_users.emp_code FROM tg_event_plan LEFT JOIN tg_customer ON tg_customer.id = tg_event_plan.customer_id  LEFT JOIN tg_system_users ON tg_system_users.id = tg_event_plan.user_id WHERE  tg_event_plan.deleted = ?  "+ whereCondition +" ORDER BY tg_event_plan.id DESC LIMIT ? OFFSET ? ";
        var filter = [0,postData.limit, postData.start];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


SFA_Master.updateEventPlanStatus = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            updated_on:nowDateTime,
            status: postData.status ? postData.status : 'Pending',
            status_remark: postData.status_remark ? postData.status_remark : '',
        }
        
        // console.log('updateDataValues',updateDataValues);
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_event_plan", updateDataValues, postData.event_plan_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


SFA_Master.deleteEventPlanData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            updated_on:nowDateTime,
            deleted: 1
        }
        
        // console.log('updateDataValues',updateDataValues);
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_event_plan", updateDataValues, postData.event_plan_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.detailEventPlanData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        var queryString = "SELECT tg_event_plan.*,tg_customer.first_name,tg_customer.last_name, tg_customer.company_name,tg_customer.street,tg_customer.state_name,tg_customer.district_name,tg_customer.mobile as mobile_no FROM tg_event_plan LEFT JOIN tg_customer ON tg_customer.id = tg_event_plan.customer_id WHERE  tg_event_plan.deleted = ?  AND tg_event_plan.id  = ? "+whereCondition+" ORDER BY tg_event_plan.ID DESC";
        var filter = [0, postData.event_plan_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


SFA_Master.detailEventPlanParticipantData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        var queryString = "SELECT tg_event_plan_participant.*, IF(tg_event_plan_participant.filename != '',CONCAT('"+postData.image_app_path+"', tg_event_plan_participant.filename), '') as filename_path  FROM tg_event_plan_participant WHERE  tg_event_plan_participant.deleted = ? AND tg_event_plan_participant.event_plan_id = ? AND tg_event_plan_participant.type = ?  "+whereCondition+" ORDER BY tg_event_plan_participant.ID ASC";
        var filter = [0, postData.event_plan_id, postData.type];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



SFA_Master.getMasterSearchDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition_DR = '';
        var whereCondition_User = '';
        if(postData.filter.search){
            whereCondition_DR += " AND (tg_customer.company_name LIKE '%"+postData.filter.search+"%'  OR tg_customer.cust_code LIKE '%"+postData.filter.search+"%' OR tg_customer.mobile LIKE '%"+postData.filter.search+"%' )"; 
            
            whereCondition_User += " AND (tg_system_users.name LIKE '%"+postData.filter.search+"%'  OR tg_system_users.mobile_no LIKE '%"+postData.filter.search+"%' )"; 
            
        }
        
        var queryString_DR = "( SELECT tg_customer.id as id, tg_customer.company_name as name, tg_customer.cust_code as code, tg_customer.mobile as mobile_no, tg_customer.cust_type  as `type`, tg_customer.email, tg_customer.state_name, tg_customer.district_name, tg_customer.city, tg_customer.area, tg_customer.pincode, tg_customer.created_on,  tg_customer.is_lead, '-' as for_sales_user, '-' as for_system_user,  'Distribution Network' as search_type, 'tg_customer' as table_name FROM tg_customer WHERE 1 = 1  "+whereCondition_DR +" )";
        
        var queryString_User = "( SELECT tg_system_users.id, tg_system_users.name, tg_system_users.emp_code as code, tg_system_users.mobile_no, tg_system_users.designation as `type`, tg_system_users.email, tg_system_users.state_name, tg_system_users.district_name, tg_system_users.city, tg_system_users.area, tg_system_users.pincode, tg_system_users.created_on, '-' as is_lead, tg_master_role.for_sales_user, tg_master_role.for_system_user,  'Sales/System Users' as search_type, 'tg_system_users' as table_name FROM tg_system_users LEFT JOIN tg_master_role ON tg_master_role.id = tg_system_users.role WHERE 1 = 1  "+whereCondition_User+") ";
        
        
        var queryString = queryString_DR + ' UNION '  + queryString_User;
        var filter = [];
        
        // console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};






SFA_Master.trackUserLocationCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.created_on){
            whereCondition += " AND (DATE(tg_system_users_location.created_on) = '"+moment(postData.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.user_id){
            whereCondition += " AND (tg_system_users_location.user_id = '"+postData.user_id+"')"; 
        }

        if(postData.attendance_id){
            whereCondition += " AND (tg_system_users_location.attendance_id = '"+postData.attendance_id+"')"; 
        }
        
        var queryString = "SELECT  IF(COUNT(tg_system_users_location.id),COUNT(tg_system_users_location.id),0) as totalCount  FROM ?? WHERE 1 = 1 "+ whereCondition;
        var filter = ['tg_system_users_location'];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var totalCount = 0;
                if(res.length){
                    totalCount = res[0].totalCount ? res[0].totalCount : 0;
                }
                resolve(totalCount);
            }
        });
    });
};



SFA_Master.trackUserLocationList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';     
        
        
        if(postData.created_on){
            whereCondition += " AND (DATE(tg_system_users_location.created_on) = '"+moment(postData.created_on).format('YYYY-MM-DD')+"')"; 
        }
        
        if(postData.user_id){
            whereCondition += " AND (tg_system_users_location.user_id = '"+postData.user_id+"')"; 
        }
        
        if(postData.attendance_id){
            whereCondition += " AND (tg_system_users_location.attendance_id = '"+postData.attendance_id+"')"; 
        }
        
        var queryString = "SELECT tg_system_users_location.*,tg_system_users.name,tg_system_users.mobile_no,tg_system_users.emp_code FROM tg_system_users_location LEFT JOIN tg_system_users ON tg_system_users.id = tg_system_users_location.user_id WHERE  1 = 1 "+ whereCondition +" ORDER BY tg_system_users_location.id ASC";
        var filter = [];
        
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, async function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.user_encrypt_id = encrypt(x.user_id.toString());
                        x.label = '';
                        x.label += x.attendance_id != 0 ? x.track_type + '<br>' : '';
                        x.label += x.checkin_id != 0 ? x.track_type + '<br>' : '';
                        x.label += 'Address - '+x.address;
                        x.label += '<br> Last Updated On - '+moment(x.created_on).format('YYYY-MM-DD hh:mm:ss A');
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};




module.exports = SFA_Master;
