var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
var request = require('request');
let jwt = require('jsonwebtoken');
var md5 = require('md5');
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');


var Invoice = function (data) {
    
};



Invoice.getDrList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.search+"%'  OR tg_customer.cust_code LIKE '%"+postData.filter.search+"%' OR tg_customer.mobile LIKE '%"+postData.filter.search+"%' )"; 
        }
        if(postData.filter.company_name){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.company_name+"%')"; 
        }
        if(postData.filter.cust_code){
            whereCondition += " AND (tg_customer.cust_code LIKE '%"+postData.filter.cust_code+"%')"; 
        }
        if(postData.filter.email){
            whereCondition += " AND (tg_customer.email LIKE '%"+postData.filter.email+"%')"; 
        }
        if(postData.filter.mobile){
            whereCondition += " AND (tg_customer.mobile LIKE '%"+postData.filter.mobile+"%')"; 
        }
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_customer_order.customer_id,tg_customer.id,tg_customer.company_name,tg_customer.cust_code,tg_customer.email,tg_customer.mobile,tg_customer.cust_type, tg_customer.state_name, tg_customer.credit_day,tg_customer.gst_no  FROM tg_customer_order LEFT JOIN tg_customer ON tg_customer.id =  tg_customer_order.customer_id WHERE  1 = 1 "+ whereCondition +" GROUP BY tg_customer_order.customer_id ORDER BY tg_customer.company_name ASC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Invoice.getDrOrderList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_customer_order.customer_id, tg_customer_order.id,tg_customer_order.order_no FROM tg_customer_order WHERE tg_customer_order.customer_id = ? AND tg_customer_order.order_status  IN ('Pending', 'Hold') ORDER BY tg_customer_order.id ASC";
        var filter = [postData.customer_id];
        
        // console.log('queryString',queryString)
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Invoice.getDrOrderItemDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_customer_order.order_no,tg_customer_order.order_status, tg_customer_order.id as order_id FROM tg_customer_order WHERE  tg_customer_order.id IN (?) ORDER BY tg_customer_order.id ASC";
        var filter = [postData.order_id];
        
        // console.log('queryString',queryString)
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async element => {
                        var getDrOrderItemData = await Invoice.getDrOrderItemData(element); 
                        // console.log('getDrOrderItemData',getDrOrderItemData);
                        element.order_detail = getDrOrderItemData;
                        if(i == 0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


Invoice.getDrOrderItemData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_customer_order_item.*, tg_master_product.product_name,tg_master_product.product_code,tg_master_product.product_group, tg_master_product.unit,tg_master_product.brand  FROM tg_customer_order_item LEFT JOIN tg_master_product ON tg_master_product.id = tg_customer_order_item.product_id   WHERE  tg_customer_order_item.order_id IN (?) ORDER BY tg_customer_order_item.id ASC";
        var filter = [postData.order_id];
        
        // console.log('queryString',queryString)
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




Invoice.getInvoiceNo = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT invoice_no FROM tg_customer_invoice ORDER BY id DESC LIMIT 1";
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


Invoice.getInvoiceCount = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        if(postData.filter.invoice_no){
            whereCondition += " AND (tg_customer_invoice.invoice_no LIKE '%"+postData.filter.invoice_no+"%')"; 
        }
        if(postData.filter.cust_type){
            whereCondition += " AND (tg_customer.cust_type LIKE '%"+postData.filter.cust_type+"%')"; 
        }
        if(postData.filter.dr_data){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.dr_data+"%' OR tg_customer.mobile LIKE '%"+postData.filter.dr_data+"%' OR  tg_customer.cust_code LIKE '%"+postData.filter.dr_data+"%' OR  tg_customer.email LIKE '%"+postData.filter.dr_data+"%' )"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (tg_customer_invoice.created_on = '"+postData.filter.created_on+"')"; 
        }
        if(postData.filter.order_status){
            whereCondition += " AND (tg_customer_invoice.order_status = '"+postData.filter.order_status+"')"; 
        }
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_customer_invoice.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        if(postData.filter.created_by_name){
            whereCondition += " AND (tg_customer_invoice.created_by_name LIKE '%"+postData.filter.created_by_name+"%')"; 
        }
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT IF(COUNT(tg_customer_invoice.id),COUNT(tg_customer_invoice.id),0) as totalCount FROM tg_customer_invoice LEFT JOIN tg_customer ON tg_customer.id = tg_customer_invoice.customer_id  WHERE  1 = 1 AND tg_customer_invoice.del = ? "+ whereCondition;
        var filter = [0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Invoice.getInvoiceList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.invoice_no){
            whereCondition += " AND (tg_customer_invoice.invoice_no LIKE '%"+postData.filter.invoice_no+"%')"; 
        }
        if(postData.filter.cust_type){
            whereCondition += " AND (tg_customer.cust_type LIKE '%"+postData.filter.cust_type+"%')"; 
        }
        if(postData.filter.dr_data){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.dr_data+"%' OR tg_customer.mobile LIKE '%"+postData.filter.dr_data+"%' OR  tg_customer.cust_code LIKE '%"+postData.filter.dr_data+"%' OR  tg_customer.email LIKE '%"+postData.filter.dr_data+"%' )"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (tg_customer_invoice.created_on = '"+postData.filter.created_on+"')"; 
        }
        if(postData.filter.order_status){
            whereCondition += " AND (tg_customer_invoice.order_status = '"+postData.filter.order_status+"')"; 
        }
        if(postData.filter.created_by_name){
            whereCondition += " AND (tg_customer_invoice.created_by_name LIKE '%"+postData.filter.created_by_name+"%')"; 
        }
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_customer_invoice.customer_id = '"+postData.filter.customer_id+"')"; 
        }

        if(postData.filter.order_id){
            whereCondition += " AND (FIND_IN_SET('"+postData.filter.order_id+"', tg_customer_invoice.order_id))"; 
        }

        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_customer_invoice.*, tg_customer.company_name, tg_customer.cust_code, tg_customer.email,tg_customer.mobile,tg_customer.landline_no,tg_customer.cust_type FROM tg_customer_invoice LEFT JOIN tg_customer ON tg_customer.id = tg_customer_invoice.customer_id  WHERE  1 = 1 AND tg_customer_invoice.del = ? "+ whereCondition +" ORDER BY tg_customer_invoice.id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {

                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }

            }
        });
    });
};


Invoice.addInvoiceData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            customer_id: postData.customer_id ? postData.customer_id : 0,
            order_id: postData.order_id ? postData.order_id : 0,
            order_no: postData.order_no ? postData.order_no : '',
            invoice_no: postData.invoice_no ? postData.invoice_no : null,
            invoice_date: postData.invoice_date ? postData.invoice_date : '',
            invoice_total :  postData.invoice_total ? postData.invoice_total : 0,
            basic_amount :  postData.amount ? postData.amount : 0,
            total_item: postData.total_item ? postData.total_item : 0,
            total_qty: postData.total_qty ? postData.total_qty : 0,
            freight_amt: postData.freight_amt ? postData.freight_amt : 0,
            cgst_amt: postData.cgst_amt ? postData.cgst_amt : 0,
            sgst_amt: postData.sgst_amt ? postData.sgst_amt : 0,
            igst_amt: postData.igst_amt ? postData.igst_amt : 0,
            total_amt: postData.total_amt ? postData.total_amt : 0,
            tax_amt: postData.tax_amt ? postData.tax_amt : 0,
            remark: postData.remark ? postData.remark : '',
            del: postData.del ? postData.del : 0,
            created_by: postData.created_by ? postData.created_by : 0,
            created_by_name: postData.created_by_name ? postData.created_by_name : '',
            updated_on: nowDateTime,
            created_on: nowDateTime,
            created_by : postData.sfa_web_user_id ? postData.sfa_web_user_id : 0,
            created_by_name : postData.sfa_web_user_name ? postData.sfa_web_user_name : ''
        }
        
        var queryString = "INSERT INTO tg_customer_invoice set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Invoice.addInvoiceItemData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            invoice_id: postData.invoice_id ? postData.invoice_id : 0,
            customer_id: postData.customer_id ? postData.customer_id : 0,
            product_id: postData.product_id ? postData.product_id : 0,
            qty: postData.dispatch_qty ? postData.dispatch_qty : 0,
            dispatch_qty_amount :  postData.dispatch_qty_amount ? postData.dispatch_qty_amount : 0,
            rate: postData.rate ? postData.rate : 0,
            discount_amt: postData.discount_amt ? postData.discount_amt : 0,
            discount: postData.discount ? postData.discount : 0,
            tax: postData.tax ? postData.tax : 0,
            tax_amt: postData.tax_amt ? postData.tax_amt : 0,
            total_amt: postData.total_amt ? postData.total_amt : 0,
            status: postData.status ? postData.status : 1,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_customer_invoice_item set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};




Invoice.updateOrderItemQty = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var queryString = "UPDATE ?? SET dispatch_qty = dispatch_qty + ? ,pending_qty = pending_qty - ?, updated_on = ?  WHERE id = ?;"
        var filter = ["tg_customer_order_item", postData.dispatch_qty?postData.dispatch_qty:0, postData.dispatch_qty?postData.dispatch_qty:0,  nowDateTime, postData.order_item_id];
        
        console.log('queryString',queryString);
        console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Invoice.checkOrderPendingQty = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT IF(SUM(tg_customer_order_item.pending_qty),SUM(tg_customer_order_item.pending_qty),0) as pending_qty  FROM tg_customer_order_item WHERE tg_customer_order_item.order_id = ?";
        var filter = [postData.order_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


Invoice.updateOrderStatus = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var queryString = "UPDATE ?? SET `order_status` = ?, updated_on = ?  WHERE id = ?;"
        var filter = ["tg_customer_order",  'Dispatch', nowDateTime, postData.order_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Invoice.getInvoiceBasicDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_customer_invoice.*,tg_customer.cust_type_id, tg_customer.company_name,tg_customer.gst_no,tg_customer.street,tg_customer.state_name,tg_customer.district_name, tg_customer.city,tg_customer.area,tg_customer.zone,tg_customer.pincode, tg_customer.cust_code, tg_customer.email,tg_customer.mobile,tg_customer.landline_no,tg_customer.cust_type FROM tg_customer_invoice LEFT JOIN tg_customer ON tg_customer.id = tg_customer_invoice.customer_id  WHERE tg_customer_invoice.id = ?";
        var filter = [postData.invoice_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    res[0].customer_encrypt_id = encrypt(res[0].customer_id.toString());
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


Invoice.getInvoiceItemDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_customer_invoice_item.*, tg_master_product.product_name,tg_master_product.product_code,tg_master_product.product_group, tg_master_product.unit , tg_master_product.hsn_code FROM tg_customer_invoice_item LEFT JOIN tg_master_product ON tg_master_product.id = tg_customer_invoice_item.product_id  WHERE tg_customer_invoice_item.invoice_id = ?";
        var filter = [postData.invoice_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Invoice.deleteInvoiceData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var queryString = "UPDATE ?? SET `del` = ?, updated_on = ?  WHERE id = ?;"
        var filter = ["tg_customer_invoice",  '1', nowDateTime, postData.invoice_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Invoice.deleteInvoiceDataItem = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');

        var queryString = "UPDATE ?? SET `status` = ?, updated_on = ?  WHERE invoice_id = ?;"
        var filter = ["tg_customer_invoice_item",  '0', nowDateTime, postData.invoice_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


module.exports = Invoice;
