var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
var request = require('request');
let jwt = require('jsonwebtoken');
var md5 = require('md5');
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');


var Order = function (data) {
    
};



Order.getDrList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (company_name LIKE '%"+postData.filter.search+"%'  OR cust_code LIKE '%"+postData.filter.search+"%' OR mobile LIKE '%"+postData.filter.search+"%' )"; 
        }
        if(postData.filter.company_name){
            whereCondition += " AND (company_name LIKE '%"+postData.filter.company_name+"%')"; 
        }
        if(postData.filter.cust_code){
            whereCondition += " AND (cust_code LIKE '%"+postData.filter.cust_code+"%')"; 
        }
        if(postData.filter.email){
            whereCondition += " AND (email LIKE '%"+postData.filter.email+"%')"; 
        }
        if(postData.filter.mobile){
            whereCondition += " AND (mobile LIKE '%"+postData.filter.mobile+"%')"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (created_on = '"+postData.filter.created_on+"')"; 
        }
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT id,company_name,cust_code,email,mobile,cust_type, credit_day , gst_no FROM tg_customer WHERE  1 = 1 "+ whereCondition +" ORDER BY status DESC, company_name ASC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Order.getDrProductDiscountListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT product_id,customer_id,min_qty,discount FROM ?? WHERE  product_id = ? AND customer_id = ? AND deleted = ?";
        var filter = ['tg_customer_product_discount', postData.product_id, postData.customer_id, 0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Order.getProductList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (product_name LIKE '%"+postData.filter.search+"%'  OR product_code LIKE '%"+postData.filter.search+"%' OR product_group LIKE '%"+postData.filter.search+"%' OR description LIKE '%"+postData.filter.search+"%')"; 
        }
        if(postData.filter.product_name){
            whereCondition += " AND (product_name LIKE '%"+postData.filter.product_name+"%')"; 
        }
        if(postData.filter.product_code){
            whereCondition += " AND (product_code LIKE '%"+postData.filter.product_code+"%')"; 
        }

        if(postData.filter.vendor_product_name){
            whereCondition += " AND (vendor_product_name LIKE '%"+postData.filter.vendor_product_name+"%')"; 
        }
        if(postData.filter.vendor_product_code){
            whereCondition += " AND (vendor_product_code LIKE '%"+postData.filter.vendor_product_code+"%')"; 
        }

        if(postData.filter.product_group){
            whereCondition += " AND (product_group LIKE '%"+postData.filter.product_group+"%')"; 
        }
        if(postData.filter.description){
            whereCondition += " AND (description LIKE '%"+postData.filter.description+"%')"; 
        }
        if(postData.filter.status){
            whereCondition += " AND (status LIKE '%"+postData.filter.status+"%')"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (created_on = '"+postData.filter.created_on+"')"; 
        }
        
        var queryString = "SELECT id,product_name,vendor_product_name, product_code, vendor_product_code,product_group,sale_price,tax_percentage,discount_percentage,hsn_code,stock_qty FROM tg_master_product WHERE  1 = 1 "+ whereCondition +" ORDER BY status DESC, product_name ASC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Order.getRejectReasonListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        var queryString = "SELECT * FROM tg_master_reject_reason WHERE status = ? ";
        var filter = [1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Order.getSaleOrderNo = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT order_no FROM tg_customer_order ORDER BY id DESC LIMIT 1";
        var filter = [];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};



Order.getOrderStatusType = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT name FROM tg_order_status WHERE status = ? ORDER BY ordering ASC ";
        var filter = [1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(i > 0){
                    res.forEach(async element => {
                        var getOrderStatusCount = await Order.getOrderStatusCount({'order_status' : element.name, 'sfa_web_user_type' : postData.sfa_web_user_type, 'sfa_web_user_id' : postData.sfa_web_user_id});
                        // console.log('getOrderStatusCount',getOrderStatusCount);
                        element.count = getOrderStatusCount;
                        if(i == 0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};



Order.getOrderStatusCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        if(postData.sfa_web_user_type == 'dealer'){
            var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_customer_order WHERE order_status = ? AND del = ? AND created_by_type = ? AND created_by = ?";
            var filter = [postData.order_status,0,postData.sfa_web_user_type, postData.sfa_web_user_id];
        }else{
            var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_customer_order WHERE order_status = ? AND del = ?";
            var filter = [postData.order_status,0];
        }
     
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data)
            }
        });
    });
};



Order.getOrderAmountSum = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        if(postData.filter.order_no){
            whereCondition += " AND (tg_customer_order.order_no LIKE '%"+postData.filter.order_no+"%')"; 
        }
        if(postData.filter.cust_type){
            whereCondition += " AND (tg_customer.cust_type LIKE '%"+postData.filter.cust_type+"%')"; 
        }
        if(postData.filter.dr_data){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.dr_data+"%' OR tg_customer.mobile LIKE '%"+postData.filter.dr_data+"%' OR  tg_customer.cust_code LIKE '%"+postData.filter.dr_data+"%' OR  tg_customer.email LIKE '%"+postData.filter.dr_data+"%' )"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (tg_customer_order.created_on = '"+postData.filter.created_on+"')"; 
        }
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_customer_order.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        if(postData.filter.order_status){
            whereCondition += " AND (tg_customer_order.order_status = '"+postData.filter.order_status+"')"; 
        }

        if(postData.filter.order_type){
            whereCondition += " AND (tg_customer_order.order_type = '"+postData.filter.order_type+"')"; 
        }

        if(postData.filter.created_by){
            whereCondition += " AND (tg_customer_order.created_by = '"+postData.filter.created_by+"')"; 
        }

        if(postData.filter.created_by_name){
            whereCondition += " AND (tg_customer_order.created_by_name LIKE '%"+postData.filter.created_by_name+"%')"; 
        }
        
        if(postData.sfa_web_user_type == 'dealer'){
            whereCondition += " AND (tg_customer_order.created_by  = '"+postData.sfa_web_user_id+"' )"; 
        }

        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT IF(SUM(tg_customer_order.total_amt),SUM(tg_customer_order.total_amt),0) as total_amt FROM tg_customer_order  WHERE  1 = 1 AND tg_customer_order.del = ? "+ whereCondition;
        var filter = [0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].total_amt;
                }
                resolve(data);
            }
        });
    });
};


Order.getOrderCount = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        if(postData.filter.order_no){
            whereCondition += " AND (tg_customer_order.order_no LIKE '%"+postData.filter.order_no+"%')"; 
        }
        if(postData.filter.cust_type){
            whereCondition += " AND (tg_customer.cust_type LIKE '%"+postData.filter.cust_type+"%')"; 
        }
        if(postData.filter.dr_data){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.dr_data+"%' OR tg_customer.mobile LIKE '%"+postData.filter.dr_data+"%' OR  tg_customer.cust_code LIKE '%"+postData.filter.dr_data+"%' OR  tg_customer.email LIKE '%"+postData.filter.dr_data+"%' )"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_customer_order.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }

        if(postData.filter.customer_id){
            whereCondition += " AND (tg_customer_order.customer_id = '"+postData.filter.customer_id+"')"; 
        }

        if(postData.filter.user_id){
            whereCondition += " AND (tg_customer_order.created_by = '"+postData.filter.user_id+"' AND tg_customer_order.created_by_type = 'app')"; 
        }

        if(postData.filter.order_status){
            whereCondition += " AND (tg_customer_order.order_status = '"+postData.filter.order_status+"')"; 
        }

        if(postData.filter.order_type){
            whereCondition += " AND (tg_customer_order.order_type = '"+postData.filter.order_type+"')"; 
        }

        if(postData.filter.created_by_name){
            whereCondition += " AND (tg_customer_order.created_by_name LIKE '%"+postData.filter.created_by_name+"%')"; 
        }
        
        if(postData.sfa_web_user_type == 'dealer'){
            whereCondition += " AND (tg_customer_order.created_by  = '"+postData.sfa_web_user_id+"' )"; 
        }

        if(postData.filter.created_by){
            whereCondition += " AND (tg_customer_order.created_by = '"+postData.filter.created_by+"')"; 
        }

        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT IF(COUNT(tg_customer_order.id),COUNT(tg_customer_order.id),0) as totalCount FROM tg_customer_order LEFT JOIN tg_customer ON tg_customer.id = tg_customer_order.customer_id  WHERE  1 = 1 AND tg_customer_order.del = ? "+ whereCondition;
        var filter = [0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);

        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Order.getOrderList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.order_no){
            whereCondition += " AND (tg_customer_order.order_no LIKE '%"+postData.filter.order_no+"%')"; 
        }
        if(postData.filter.cust_type){
            whereCondition += " AND (tg_customer.cust_type LIKE '%"+postData.filter.cust_type+"%')"; 
        }
        if(postData.filter.dr_data){
            whereCondition += " AND (tg_customer.company_name LIKE '%"+postData.filter.dr_data+"%' OR tg_customer.mobile LIKE '%"+postData.filter.dr_data+"%' OR  tg_customer.cust_code LIKE '%"+postData.filter.dr_data+"%' OR  tg_customer.email LIKE '%"+postData.filter.dr_data+"%' )"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (tg_customer_order.created_on = '"+postData.filter.created_on+"')"; 
        }
        if(postData.filter.order_status){
            whereCondition += " AND (tg_customer_order.order_status = '"+postData.filter.order_status+"')"; 
        }
        if(postData.filter.customer_id){
            whereCondition += " AND (tg_customer_order.customer_id = '"+postData.filter.customer_id+"')"; 
        }
        if(postData.filter.created_by_name){
            whereCondition += " AND (tg_customer_order.created_by_name LIKE '%"+postData.filter.created_by_name+"%')"; 
        }

        if(postData.filter.order_type){
            whereCondition += " AND (tg_customer_order.order_type = '"+postData.filter.order_type+"')"; 
        }

        if(postData.filter.user_id){
            whereCondition += " AND (tg_customer_order.created_by = '"+postData.filter.user_id+"' AND tg_customer_order.created_by_type = 'app')"; 
        }

        if(postData.sfa_web_user_type == 'dealer'){
            whereCondition += " AND (tg_customer_order.created_by  = '"+postData.sfa_web_user_id+"' )"; 
        }
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT tg_customer_order.*, tg_customer.company_name, tg_customer.cust_code, tg_customer.email,tg_customer.mobile,tg_customer.landline_no,tg_customer.cust_type FROM tg_customer_order LEFT JOIN tg_customer ON tg_customer.id = tg_customer_order.customer_id  WHERE  1 = 1 AND tg_customer_order.del = ? "+ whereCondition +" ORDER BY tg_customer_order.id DESC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
                
            }
        });
    });
};



Order.addOrderData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            customer_id: postData.customer_id ? postData.customer_id : 0,
            order_no: postData.order_no ? postData.order_no : null,
            order_date: postData.order_date ? postData.order_date : '',
            delivery_date: postData.delivery_date ? postData.delivery_date : '',
            payment_date: postData.payment_date ? postData.payment_date : '',
            order_status: postData.order_status ? postData.order_status : 'Pending',
            total_item: postData.total_item ? postData.total_item : 0,
            total_qty: postData.total_qty ? postData.total_qty : 0,
            total_amt: postData.total_amt ? postData.total_amt : 0,
            tax_amt: postData.tax_amt ? postData.tax_amt : 0,
            discount_amt: postData.discount_amt ? postData.discount_amt : 0,
            net_amt: postData.net_amt ? postData.net_amt : 0,
            sub_total: postData.sub_total ? postData.sub_total : 0,
            remark: postData.remark ? postData.remark : '',
            del: postData.del ? postData.del : 0,
            created_by: postData.created_by ? postData.created_by : 0,
            created_by_type : postData.created_by_type ? postData.created_by_type : '',
            created_by_name: postData.created_by_name ? postData.created_by_name : '',
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_customer_order set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Order.updateOrderData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            customer_id: postData.customer_id ? postData.customer_id : 0,
            order_no: postData.order_no ? postData.order_no : null,
            order_date: postData.order_date ? postData.order_date : '',
            delivery_date: postData.delivery_date ? postData.delivery_date : '',
            payment_date: postData.payment_date ? postData.payment_date : '',
            order_status: postData.order_status ? postData.order_status : 'Pending',
            total_item: postData.total_item ? postData.total_item : 0,
            total_qty: postData.total_qty ? postData.total_qty : 0,
            total_amt: postData.total_amt ? postData.total_amt : 0,
            tax_amt: postData.tax_amt ? postData.tax_amt : 0,
            discount_amt: postData.discount_amt ? postData.discount_amt : 0,
            net_amt: postData.net_amt ? postData.net_amt : 0,
            sub_total: postData.sub_total ? postData.sub_total : 0,
            remark: postData.remark ? postData.remark : '',
            del: postData.del ? postData.del : 0,
            updated_on: nowDateTime,
        }
        
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_order", updateDataValues, postData.id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Order.deleteOrderItemData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            status : 0,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE order_id = ?;"
        var filter = ["tg_customer_order_item", updateDataValues, postData.id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Order.addOrderItemData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            order_id: postData.order_id ? postData.order_id : 0,
            customer_id: postData.customer_id ? postData.customer_id : 0,
            product_id: postData.product_id ? postData.product_id : 0,
            order_qty: postData.order_qty ? postData.order_qty : 0,
            dispatch_qty: postData.dispatch_qty ? postData.dispatch_qty : 0,
            pending_qty: postData.pending_qty ? postData.pending_qty : 0,
            rate: postData.rate ? postData.rate : 0,
            discount_amt: postData.discount_amt ? postData.discount_amt : 0,
            discount: postData.discount ? postData.discount : 0,
            tax: postData.tax ? postData.tax : 0,
            tax_amt: postData.tax_amt ? postData.tax_amt : 0,
            sub_total: postData.sub_total ? postData.sub_total : 0,
            net_amt: postData.net_amt ? postData.net_amt : 0,
            total_amt: postData.total_amt ? postData.total_amt : 0,
            status: postData.status ? postData.status : 1,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_customer_order_item set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Order.getOrderBasicDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_customer_order.*,tg_customer.cust_type_id, tg_customer.company_name, tg_customer.cust_code, tg_customer.email,tg_customer.mobile,tg_customer.landline_no,tg_customer.cust_type FROM tg_customer_order LEFT JOIN tg_customer ON tg_customer.id = tg_customer_order.customer_id WHERE tg_customer_order.id = ?";
        var filter = [postData.order_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    res[0].customer_encrypt_id = encrypt(res[0].customer_id.toString());
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


Order.getOrderItemDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_customer_order_item.*, tg_master_product.product_name,tg_master_product.product_code,tg_master_product.product_group, tg_master_product.unit  FROM tg_customer_order_item LEFT JOIN tg_master_product ON tg_master_product.id = tg_customer_order_item.product_id  WHERE tg_customer_order_item.order_id = ?";
        var filter = [postData.order_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Order.orderDelete = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            del: 1,
            updated_on: nowDateTime      
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_order", updateDataValues, postData.order_id];
        
        // console.log('updateDataValues',updateDataValues,postData);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Order.updateOrderStatus = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            order_status : postData.status,
            order_status_remark : postData.order_status_remark ? postData.order_status_remark :'',
            updated_on: nowDateTime      
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_customer_order", updateDataValues, postData.order_id];
        
        // console.log('updateDataValues',updateDataValues,postData);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


module.exports = Order;
