var db = require('../../config/db');
var path = require('path');
const SFA_Master = require("./../../models/web/SFA_masterModel");
const Network = require("./../../models/web/networkModel");
var moment = require('moment');
var http = require("https");
var request = require('request');
let jwt = require('jsonwebtoken');
var md5 = require('md5');
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');


var User = function (data) {
    
};


User.login = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_system_users.id,tg_system_users.session_token,tg_system_users.name,tg_system_users.username,tg_system_users.role,tg_master_role.name as role_name FROM tg_system_users LEFT JOIN tg_master_role ON tg_master_role.id =  tg_system_users.role WHERE tg_system_users.status = ? AND tg_system_users.username = ? AND  tg_system_users.md5_password = ?";
        var filter = [1, postData.username, md5(postData.password)];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.updateSessionToken = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        // var tokenData = { 'name': postData.name ? postData.name : '', 'mobile_no': postData.mobile_no ? postData.mobile_no : '', 'password': postData.password ? postData.password : '' };
        // let token = jwt.sign({ tokenData }, global.config.secretKey, {
        //     algorithm: global.config.algorithm,
        // });
        // postData.session_token = token;
        
        postData.session_token = postData.username + '-' + postData.id;
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_system_users SET session_token = ?, updated_on = ? WHERE id = ?;"
        var filter = [postData.session_token, nowDateTime, postData.id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log('res ==>',res);
                res.session_token = postData.session_token;
                resolve(res);
            }
        });
    });
};


// dealer login code start


User.dealerLogin = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_customer.company_name as name ,tg_customer.id,tg_customer.cust_code,tg_customer.cust_type as role_name ,tg_customer.cust_type_id, tg_customer.session_token, tg_customer.cust_type FROM tg_customer WHERE tg_customer.status = ? AND tg_customer.deleted = ? AND tg_customer.username = ? AND  tg_customer.password = ?";
        var filter = [1, 0, postData.username, postData.password];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log('res', res);
                var data = {};
                if(res.length){
                    data = res[0];
                    data.encrypt_id = encrypt(res[0].id.toString());
                }
                resolve(data);
            }
        });
    });
};


User.updateSessionTokenDealer = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var tokenData = { 'name': postData.name ? postData.name : '', 'mobile_no': postData.mobile_no ? postData.mobile_no : '', 'password': postData.password ? postData.password : '' };
        let token = jwt.sign({ tokenData }, global.config.secretKey, {
            algorithm: global.config.algorithm,
        });
        postData.session_token = token;
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_customer SET session_token = ?, updated_on = ? WHERE id = ?;"
        var filter = [postData.session_token, nowDateTime, postData.id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log('res ==>',res);
                res.session_token = postData.session_token;
                resolve(res);
            }
        });
    });
};


User.logoutDealer = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_customer SET session_token = '', updated_on = ? WHERE id = ?;"
        var filter = [nowDateTime, postData.sfa_web_user_id];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log('res ==>',res);
                res.session_token = postData.session_token;
                resolve(res);
            }
        });
    });
};


User.getDealerDetailByToken = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id,session_token,company_name as name,mobile as mobile_no,cust_code as prefix FROM tg_customer WHERE session_token = ?"
        var filter = [postData];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};

// dealer login code end


User.logoutUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "UPDATE tg_system_users SET session_token = '', updated_on = ? WHERE id = ?;"
        var filter = [nowDateTime, postData.sfa_web_user_id];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log('res ==>',res);
                res.session_token = postData.session_token;
                resolve(res);
            }
        });
    });
};



User.getUserDetailByToken = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT id,session_token,name,mobile_no,prefix FROM tg_system_users WHERE session_token = ? AND status = ?"
        var filter = [postData, 1];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                // console.log('res',res);
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.getSystemUserCount = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (tg_system_users.name LIKE '%"+postData.filter.search+"%'  OR tg_system_users.mobile_no LIKE '%"+postData.filter.search+"%' )"; 
        }
        if(postData.filter.name){
            whereCondition += " AND (tg_system_users.name LIKE '%"+postData.filter.name+"%')"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_system_users.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }

        if(postData.filter.last_used){
            whereCondition += " AND (DATE(tg_system_users.last_used) = '"+moment(postData.filter.last_used).format('YYYY-MM-DD')+"')"; 
        }
        

        if(postData.filter.status){
            whereCondition += " AND (tg_system_users.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.for_system_user){
            whereCondition += " AND (tg_master_role.for_system_user = '"+postData.filter.for_system_user+"')"; 
        }
        
        
        if(postData.filter.for_sales_user){
            whereCondition += " AND (tg_master_role.for_sales_user = '"+postData.filter.for_sales_user+"')"; 
        }
        
        // if(postData.filter.role){
        //     whereCondition += " AND (tg_system_users.role = '"+postData.filter.role+"')"; 
        // }
        
        var queryString = "SELECT IF(COUNT(tg_system_users.id),COUNT(tg_system_users.id),0) as totalCount FROM tg_system_users  LEFT JOIN tg_master_role ON tg_master_role.id = tg_system_users.role WHERE  tg_system_users.deleted = ? "+ whereCondition
        var filter = [0];
        
        console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


User.getSystemUserList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (tg_system_users.name LIKE '%"+postData.filter.search+"%'  OR tg_system_users.mobile_no LIKE '%"+postData.filter.search+"%' )"; 
        }
        if(postData.filter.name){
            whereCondition += " AND (tg_system_users.name LIKE '%"+postData.filter.name+"%')"; 
        }
      
        if(postData.filter.created_on){
            whereCondition += " AND (DATE(tg_system_users.created_on) = '"+moment(postData.filter.created_on).format('YYYY-MM-DD')+"')"; 
        }

        if(postData.filter.last_used){
            whereCondition += " AND (DATE(tg_system_users.last_used) = '"+moment(postData.filter.last_used).format('YYYY-MM-DD')+"')"; 
        }
        
        
        if(postData.filter.status){
            whereCondition += " AND (tg_system_users.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.for_system_user){
            whereCondition += " AND (tg_master_role.for_system_user = '"+postData.filter.for_system_user+"')"; 
        }
        
        
        if(postData.filter.for_sales_user){
            whereCondition += " AND (tg_master_role.for_sales_user = '"+postData.filter.for_sales_user+"')"; 
        }
        
        var queryString = "SELECT tg_system_users.*,tg_master_role.name as role FROM tg_system_users LEFT JOIN tg_master_role ON tg_master_role.id = tg_system_users.role WHERE  tg_system_users.deleted = ? "+ whereCondition +" ORDER BY id DESC, name ASC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async x => {
                        x.product_division = [];
                        var getSalesUserAssignedProductDivision = await User.getSalesUserAssignedProductDivision({'user_id' : x.id});
                        var getSalesUserReportingUser = await User.getSalesUserReportingUser({'user_id' : x.id});
                        // console.log('getSalesUserAssignedProductDivision',getSalesUserAssignedProductDivision);
                        x.product_division = getSalesUserAssignedProductDivision;
                        x.reporting_manager = getSalesUserReportingUser;
                        x.encrypt_id = encrypt(x.id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


User.addSystemUserData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        
        var tokenData = { 'name': postData.name ? postData.name : '', 'mobile_no': postData.mobile_no ? postData.mobile_no : '', 'password': postData.password ? postData.password : '' };
        let token = jwt.sign({ tokenData }, global.config.secretKey, {
            algorithm: global.config.algorithm,
        });
        postData.session_token = token;
        
        var insertData = {
            name: postData.name ? postData.name : '',
            mobile_no: postData.mobile_no ? postData.mobile_no : null,
            mobile_no_1: postData.mobile_no_1 ? postData.mobile_no_1 : null,
            emp_code: postData.emp_code ? postData.emp_code : null,
            email: postData.email ? postData.email : '',
            role: postData.role ? postData.role : '',
            username: postData.username ? postData.username : '',
            md5_password: postData.password ? md5(postData.password) : '',
            password: postData.password ? postData.password : '',
            session_token: postData.session_token ? postData.session_token : '',
            status: postData.status ? postData.status : 0,
            prefix: postData.prefix ? postData.prefix : '',
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_system_users set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



User.addSystemUserPermissionData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        const valueData = [];
        // console.log('postData',postData);
        if (postData.userPermission.length > 0) {
            postData.userPermission.forEach(async x => {
                valueData.push([postData.user_id, x.module_id ? x.module_id : 0, x.add ? x.add : 0, x.view ? x.view : 0, x.edit ? x.edit : 0, x.delete?x.delete:0, nowDateTime, nowDateTime]); 
            });
            
            var sql = "INSERT INTO tg_system_users_permission (user_id,module_id, `add`, `view`, `edit`, `delete`, `created_on`, `updated_on`) VALUES ?";
            db.query(sql, [valueData], function (err, res) {
                if (err) {
                    console.log("error: ", err);
                    return reject(err);
                } else {
                    resolve(res);
                }
            });
        } else {
            resolve([]);
        }
        
    });
}


User.updateSystemUserData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var tokenData = { 'name': postData.name ? postData.name : '', 'mobile_no': postData.mobile_no ? postData.mobile_no : '', 'password': postData.password ? postData.password : '' };
        let token = jwt.sign({ tokenData }, global.config.secretKey, {
            algorithm: global.config.algorithm,
        });
        postData.session_token = token;
        
        var updateDataValues = {
            name: postData.name ? postData.name : '',
            mobile_no: postData.mobile_no ? postData.mobile_no : '',
            email: postData.email ? postData.email : '',
            role: postData.role ? postData.role : '',
            username: postData.username ? postData.username : '',
            md5_password: postData.password ? md5(postData.password) : '',
            password: postData.password ? postData.password : '',
            session_token: postData.session_token ? postData.session_token : '',
            status: postData.status ? postData.status : 0,
            prefix: postData.prefix ? postData.prefix : '',
            updated_on: nowDateTime      
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_system_users", updateDataValues, postData.user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



User.updateSystemUserPermissionData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            add : postData.add ? postData.add : 0,
            edit : postData.edit ? postData.edit : 0,
            view : postData.view ? postData.view : 0,
            delete : postData.delete ? postData.delete : 0,
            updated_on: nowDateTime      
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ? AND user_id = ?;"
        var filter = ["tg_system_users_permission", updateDataValues, postData.permission_id, postData.user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.deleteSystemUserPermissionData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var queryString = "DELETE FROM ?? WHERE user_id = ?;"
        var filter = ["tg_system_users_permission", postData.user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

User.deleteSystemUserData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {           
            deleted: 1,
            mobile_no : null,
            mobile_no_1 : null,
            emp_code : null,
            email : null,
            updated_on: nowDateTime      
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_system_users", updateDataValues, postData.user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.getSystemUserDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT name,mobile_no,email,role,username,password,status,created_on,updated_on,id,prefix  FROM tg_system_users WHERE  id = ?";
        var filter = [postData.user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.getSystemUserPermissionDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        // var queryString = "SELECT backend_user_permission.view,backend_user_permission.add,backend_user_permission.edit,backend_user_permission.delete,backend_user_permission.txn_type_id,menu_link.name,menu_link.slug,menu_link.id,menu_link.parent_id FROM `backend_user_permission` JOIN menu_link ON menu_link.id = backend_user_permission.menu_id WHERE menu_link.status = 1 AND backend_user_permission.user_id = ? AND menu_link.parent_id = ? ORDER BY menu_link.ordering ASC"
        // var filter = [postData.id, 0];
        
        var queryString = "SELECT tg_system_users_permission.* ,tg_menu_data.name,tg_menu_data.slug,tg_menu_data.id as menu_id, tg_menu_data.icon , tg_menu_data.parent_id FROM tg_system_users_permission LEFT JOIN tg_menu_data ON tg_menu_data.id = tg_system_users_permission.module_id  WHERE  tg_system_users_permission.user_id = ? AND tg_menu_data.parent_id = ? AND tg_menu_data.status = ? AND tg_system_users_permission.view = ? ORDER BY tg_menu_data.ordering ASC";
        var filter = [postData.user_id, 0, 1, 1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                // resolve(true);
                reject(err);
            }
            else {
                
                if(res.length){
                    var dataCollect = new Promise((resolve, reject) => {
                        
                        var i = res.length - 1;
                        res.redirectUrl = '';
                        
                        res.forEach(async element => {
                            // console.log('element',element);
                            
                            if(element.slug == 'attendance-list' || element.slug == 'checkin-list' || element.slug == 'followup-list' || element.slug == 'leave-list' || element.slug == 'travel-list' || element.slug == 'expense-list' || element.slug == 'enquiry-list' || element.slug == 'event-plan-list'){
                                element.count_show = 1;
                                element.count = 0;
                                
                                if(element.slug == 'attendance-list'){
                                    element.count = await SFA_Master.getAttendanceTodayDataCount(element);
                                }
                                
                                if(element.slug == 'checkin-list'){
                                    element.count = await SFA_Master.getCheckinDataCount({'filter' : {'checkin_date' : moment(new Date()).format('YYYY-MM-DD') }});
                                }
                                
                                if(element.slug == 'followup-list'){
                                    element.count = await SFA_Master.getFollowupDataCount({'filter' : {'followup_date' : moment(new Date()).format('YYYY-MM-DD') }});
                                }
                                
                                if(element.slug == 'leave-list'){
                                    element.count = await SFA_Master.getLeaveDataCount({'filter' : {'created_on' : moment(new Date()).format('YYYY-MM-DD') }});
                                }
                                
                                if(element.slug == 'travel-list'){
                                    element.count = await SFA_Master.getTravelPlanDataCount({'filter' : {'created_on' : moment(new Date()).format('YYYY-MM-DD') }});
                                }
                                
                                if(element.slug == 'expense-list'){
                                    element.count = await SFA_Master.getExpenseDataCount({'filter' : {'created_on' : moment(new Date()).format('YYYY-MM-DD') }});
                                }
                                
                                if(element.slug == 'enquiry-list'){
                                    element.count = await SFA_Master.getEnquiryDataCount({'filter' : {'created_on' : moment(new Date()).format('YYYY-MM-DD') }});
                                }
                                
                                if(element.slug == 'event-plan-list'){
                                    element.count = await SFA_Master.getEventPlanDataCount({'filter' : {'created_on' : moment(new Date()).format('YYYY-MM-DD') }});
                                }
                                
                            }
                            
                            
                            
                            var queryString = "SELECT tg_system_users_permission.* ,tg_menu_data.name,tg_menu_data.slug,tg_menu_data.id as menu_id, tg_menu_data.icon , tg_menu_data.parent_id FROM tg_system_users_permission LEFT JOIN tg_menu_data ON tg_menu_data.id = tg_system_users_permission.module_id  WHERE  tg_system_users_permission.user_id = ? AND tg_menu_data.parent_id = ? AND tg_menu_data.status = ? AND tg_system_users_permission.view = ? ORDER BY tg_menu_data.ordering ASC";
                            var filter = [postData.user_id, element.module_id, 1, 1];
                            element.dropDown = [];
                            
                            // console.log('queryString',queryString);
                            // console.log('filter',filter);
                            
                            // console.log('i',i);
                            
                            db.query(queryString, filter, async function (err, resultData) {
                                if (err) {
                                    console.log("error: ", err);
                                    reject(err);
                                }
                                else {
                                    element.dropDown = resultData;
                                    if (res.redirectUrl == '') {
                                        if (resultData.length) {
                                            res.redirectUrl = resultData[0].slug; 
                                        } else {
                                            res.redirectUrl = res[0].slug;
                                        }
                                    }
                                    
                                    
                                    if(element.module_id == 2 || element.module_id == 28){
                                        // console.log('resultData',resultData);
                                        var x = resultData.length - 1;
                                        resultData.forEach(async data => {
                                            // console.log('data',data);
                                            const myArray = data.slug.split("/");
                                            // console.log('myArray', myArray);
                                            data.count_show = 1;
                                            data.count = await Network.getNetworkCount({filter:{
                                                cust_type_id : myArray[1],
                                                is_lead : element.module_id == 2 ? "0" : "1",
                                                deleted : 0
                                            }});
                                        });
                                    }                                    
                                }
                                
                                if (i === 0) {
                                    resolve();
                                }
                                // console.log(i);
                                i--;
                            });
                        });
                    });
                    dataCollect.then(async () => {
                        // console.log('res', res);
                        resolve(res);
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};




User.getModuleList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT name,icon,slug,id, parent_id  FROM tg_menu_data WHERE  status = ?";
        var filter = [1];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



User.getTempRegisterCount = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.mobile){
            whereCondition += " AND (mobile LIKE '%"+postData.filter.mobile+"%')"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (created_on = '"+postData.filter.created_on+"')"; 
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_temp_register WHERE  mobile_verified = 0 "+ whereCondition
        var filter = [];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


User.getTempRegisterListData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        
        if(postData.filter.mobile){
            whereCondition += " AND (mobile LIKE '%"+postData.filter.mobile+"%')"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (created_on = '"+postData.filter.created_on+"')"; 
        }
        
        var queryString = "SELECT *  FROM tg_temp_register WHERE  mobile_verified = 0 "+ whereCondition +" ORDER BY id ASC LIMIT ? OFFSET ? ";
        var filter = [postData.limit, postData.start];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


// sales user code start


User.addSalesUserData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            name: postData.name ? postData.name : '',
            mobile_no: postData.mobile ? postData.mobile : null,
            mobile_no_1: postData.mobile_no_1 ? postData.mobile_no_1 : null,
            email: postData.email ? postData.email : null,
            emp_code: postData.emp_code ? postData.emp_code : null,
            // role: postData.role ? postData.role : 0,
            role: postData.role?.id ? postData.role?.id : '',
            designation: postData.role?.name ? postData.role?.name : '',
            branch: postData.branch ? postData.branch : '',
            date_of_joining : postData.date_of_joining ? postData.date_of_joining : '',
            working_state : postData.working_state ? postData.working_state : '',
            street: postData.street ? postData.street : '',
            state_name: postData.state_name ? postData.state_name : '',
            district_name: postData.district_name ? postData.district_name : '',
            weekely_off : postData.weekely_off ? postData.weekely_off : '',
            city: postData.city ? postData.city : '',
            area: postData.area ? postData.area : '',
            pincode: postData.pincode ? postData.pincode : '',
            status: postData.status ? postData.status : 1,
            prefix: postData.prefix ? postData.prefix : '',
            pan_number: postData.pan_number ? postData.pan_number : '',
            aadhar_number: postData.aadhar_number ? postData.aadhar_number : '',
            bank_name: postData.bank_name?.name ? postData.bank_name?.name : '',
            account_number: postData.account_number ? postData.account_number : '',
            account_holder_name: postData.account_holder_name ? postData.account_holder_name : '',
            ifsc_code: postData.ifsc_code ? postData.ifsc_code : '',
            pan_front: postData.pan_front ? postData.pan_front : '',
            pan_back: postData.pan_back ? postData.pan_back : '',
            aadhar_front: postData.aadhar_front ? postData.aadhar_front : '',
            aadhar_back: postData.aadhar_back ? postData.aadhar_back : '',
            chequebook: postData.chequebook ? postData.chequebook : '',
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_system_users set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.updateSalesUserData = function (postData) {
    console.log("master/sales_user/add===>",postData);
    // return false;
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            name: postData.name ? postData.name : '',
            mobile_no: postData.mobile ? postData.mobile : null,
            mobile_no_1: postData.mobile_no_1 ? postData.mobile_no_1 : null,
            email: postData.email ? postData.email : null,
            emp_code: postData.emp_code ? postData.emp_code : null,
            // role: postData.role ? postData.role : 0,
            role: postData.role?.id ? postData.role?.id : '',
            date_of_joining : postData.date_of_joining ? postData.date_of_joining : '',
            designation: postData.role?.name ? postData.role?.name : '',
            branch: postData.branch ? postData.branch : '',
            weekely_off : postData.weekely_off ? postData.weekely_off : '',
            street: postData.street ? postData.street : '',
            state_name: postData.state_name ? postData.state_name : '',
            district_name: postData.district_name ? postData.district_name : '',
            city: postData.city ? postData.city : '',
            area: postData.area ? postData.area : '',
            pincode: postData.pincode ? postData.pincode : '',
            status: postData.status ? postData.status : 0,
            prefix: postData.prefix ? postData.prefix : '',            
            pan_number: postData.pan_number ? postData.pan_number : '',
            aadhar_number: postData.aadhar_number ? postData.aadhar_number : '',
            bank_name: postData.bank_name?.name ? postData.bank_name?.name : '',
            account_number: postData.account_number ? postData.account_number : '',
            account_holder_name: postData.account_holder_name ? postData.account_holder_name : '',
            ifsc_code: postData.ifsc_code ? postData.ifsc_code : '',
            pan_front: postData.pan_front ? postData.pan_front : '',
            pan_back: postData.pan_back ? postData.pan_back : '',
            aadhar_front: postData.aadhar_front ? postData.aadhar_front : '',
            aadhar_back: postData.aadhar_back ? postData.aadhar_back : '',
            chequebook: postData.chequebook ? postData.chequebook : '',
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_system_users", updateDataValues, postData.user_id];
        
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



User.deleteSalesUserAssign = function (postData) {
    return new Promise(function (resolve, reject) {
        
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE user_id = ?;"
        var filter = ["tg_system_user_assign", updateDataValues, postData.user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.salesUserAssign = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            user_id: postData.user_id ? postData.user_id : 0,
            assigned_user_id: postData.rmData.id ? postData.rmData.id : 0,
            assigned_user_name: postData.rmData.name ? postData.rmData.name : '',
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_system_user_assign set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



User.deleteSalesUserAssignState = function (postData) {
    return new Promise(function (resolve, reject) {
        
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE user_id = ?;"
        var filter = ["tg_system_user_assign_state", updateDataValues, postData.user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

User.deleteSalesUserAssignBeat = function (postData) {
    return new Promise(function (resolve, reject) {
        
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE user_id = ?;"
        var filter = ["tg_system_user_assign_beat", updateDataValues, postData.user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.deleteSalesUserAssignProductDivision = function (postData) {
    return new Promise(function (resolve, reject) {
        
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE user_id = ?;"
        var filter = ["tg_system_user_assign_product_division", updateDataValues, postData.user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.salesUserAssignState = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            user_id: postData.user_id ? postData.user_id : 0,
            state_name: postData.state_name ? postData.state_name : '',
            created_on: nowDateTime,
            updated_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_system_user_assign_state set ?";
        
        console.log('insertData',insertData);
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.salesUserAssignBeat = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            user_id: postData.user_id ? postData.user_id : 0,
            beat: postData.beat ? postData.beat : '',
            created_on: nowDateTime,
            updated_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_system_user_assign_beat set ?";
        
        console.log('insertData',insertData);
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.salesUserAssignProductDivision = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            user_id: postData.user_id ? postData.user_id : 0,
            product_division: postData.product_division ? postData.product_division : '',
            created_on: nowDateTime,
            updated_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_system_user_assign_product_division set ?";
        
        console.log('insertData',insertData);
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



User.getSalesUserDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT  tg_system_users.*, IF(tg_system_users.profile_image != '',CONCAT('"+postData.image_app_path+"', tg_system_users.profile_image), '') as profile_image_path,IF(tg_system_users.pan_front != '',CONCAT('"+postData.image_app_path+"', tg_system_users.pan_front), '') as pan_front_path,IF(tg_system_users.pan_back != '',CONCAT('"+postData.image_app_path+"', tg_system_users.pan_back), '') as pan_back_path,IF(tg_system_users.aadhar_front != '',CONCAT('"+postData.image_app_path+"', tg_system_users.aadhar_front), '') as aadhar_front_path,IF(tg_system_users.aadhar_back != '',CONCAT('"+postData.image_app_path+"', tg_system_users.aadhar_back), '') as aadhar_back_path, IF(tg_system_users.chequebook != '',CONCAT('"+postData.image_app_path+"', tg_system_users.chequebook), '') as chequebook_path FROM tg_system_users WHERE  id = ?";
        var filter = [postData.user_id];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                    data.user_encrypt_id = encrypt(data.id.toString());
                }
                console.log("salesuserdata",data)
                resolve(data);
            }
        });
    });
};


User.getSalesUserAssignedUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_system_users.id as user_id, tg_system_users.name as assigned_user_name, tg_system_users.designation,tg_system_users.mobile_no, tg_system_users.emp_code FROM  tg_system_user_assign  LEFT JOIN tg_system_users ON tg_system_users.id = tg_system_user_assign.user_id WHERE  tg_system_user_assign.assigned_user_id = ? AND tg_system_user_assign.deleted = ?  ORDER BY tg_system_user_assign.id ASC";
        var filter = [postData.user_id, 0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                // resolve(true);
                reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.user_encrypt_id = encrypt(x.user_id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


User.getSalesUserReportingUser = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_system_user_assign.*, tg_system_users.designation,tg_system_users.mobile_no,tg_system_users.emp_code FROM  tg_system_user_assign  LEFT JOIN tg_system_users ON tg_system_users.id = tg_system_user_assign.assigned_user_id WHERE  tg_system_user_assign.user_id = ? AND tg_system_user_assign.deleted = ?  ORDER BY tg_system_user_assign.id ASC";
        var filter = [postData.user_id, 0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                // resolve(true);
                reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.getSalesUserAssignedState = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_system_user_assign_state.* FROM  tg_system_user_assign_state WHERE  tg_system_user_assign_state.user_id = ? AND tg_system_user_assign_state.deleted = ?  ORDER BY tg_system_user_assign_state.id ASC";
        var filter = [postData.user_id, 0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                // resolve(true);
                reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.getSalesUserAssignedProductDivision = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT tg_system_user_assign_product_division.* FROM  tg_system_user_assign_product_division WHERE  tg_system_user_assign_product_division.user_id = ? AND tg_system_user_assign_product_division.deleted = ?  ORDER BY tg_system_user_assign_product_division.id ASC";
        var filter = [postData.user_id, 0];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                // resolve(true);
                reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


// sales user code end


// allowance code start

User.getAllowanceUserDataCount = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (tg_system_users.name LIKE '%"+postData.filter.search+"%'  OR tg_system_users.mobile_no LIKE '%"+postData.filter.search+"%' )"; 
        }
        if(postData.filter.name){
            whereCondition += " AND (tg_system_users.name LIKE '%"+postData.filter.name+"%')"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (tg_system_users.created_on = '"+postData.filter.created_on+"')"; 
        }
        
        if(postData.filter.status){
            whereCondition += " AND (tg_system_users.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.for_system_user){
            whereCondition += " AND (tg_master_role.for_system_user = '"+postData.filter.for_system_user+"')"; 
        }
        
        
        if(postData.filter.for_sales_user){
            whereCondition += " AND (tg_master_role.for_sales_user = '"+postData.filter.for_sales_user+"')"; 
        }
        
        // if(postData.filter.role){
        //     whereCondition += " AND (tg_system_users.role = '"+postData.filter.role+"')"; 
        // }
        
        var queryString = "SELECT IF(COUNT(tg_system_users.id),COUNT(tg_system_users.id),0) as totalCount FROM tg_system_users  LEFT JOIN tg_master_role ON tg_master_role.id = tg_system_users.role WHERE  tg_system_users.deleted = ? "+ whereCondition
        var filter = [0];
        
        // console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


User.getAllowanceUserDataList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (tg_system_users.name LIKE '%"+postData.filter.search+"%'  OR tg_system_users.mobile_no LIKE '%"+postData.filter.search+"%' )"; 
        }
        if(postData.filter.name){
            whereCondition += " AND (tg_system_users.name LIKE '%"+postData.filter.name+"%')"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (tg_system_users.created_on = '"+postData.filter.created_on+"')"; 
        }
        
        if(postData.filter.status){
            whereCondition += " AND (tg_system_users.status = '"+postData.filter.status+"')"; 
        }
        
        if(postData.filter.for_system_user){
            whereCondition += " AND (tg_master_role.for_system_user = '"+postData.filter.for_system_user+"')"; 
        }
        
        
        if(postData.filter.for_sales_user){
            whereCondition += " AND (tg_master_role.for_sales_user = '"+postData.filter.for_sales_user+"')"; 
        }
        
        var queryString = "SELECT tg_system_users.id, tg_system_users.name, tg_system_users.mobile_no, tg_system_users.email,tg_system_users.emp_code,  tg_master_role.name as role FROM tg_system_users LEFT JOIN tg_master_role ON tg_master_role.id = tg_system_users.role WHERE  tg_system_users.deleted = ? "+ whereCondition +" ORDER BY id DESC, name ASC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        // console.log('queryString',queryString);
        // console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(async x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        x.user_id = x.id;
                        var getUserAllowanceData = await User.getUserAllowanceData(x);
                        // console.log('getUserAllowanceData',getUserAllowanceData);
                        
                        x.te_flight = getUserAllowanceData.te_flight ? getUserAllowanceData.te_flight : 0;
                        x.te_train = getUserAllowanceData.te_train ? getUserAllowanceData.te_train : 0;
                        x.te_bus = getUserAllowanceData.te_bus ? getUserAllowanceData.te_bus : 0;
                        x.lc_metro_train = getUserAllowanceData.lc_metro_train ? getUserAllowanceData.lc_metro_train : 0;
                        x.lc_bus = getUserAllowanceData.lc_bus ? getUserAllowanceData.lc_bus : 0;
                        x.lc_auto = getUserAllowanceData.lc_auto ? getUserAllowanceData.lc_auto : 0;
                        x.lc_taxi = getUserAllowanceData.lc_taxi ? getUserAllowanceData.lc_taxi : 0;
                        x.car_per_km = getUserAllowanceData.car_per_km ? getUserAllowanceData.car_per_km : 0;
                        x.bike_per_km = getUserAllowanceData.bike_per_km ? getUserAllowanceData.bike_per_km : 0;
                        x.hotel_allowance = getUserAllowanceData.hotel_allowance ? getUserAllowanceData.hotel_allowance : 0;
                        x.food_allowance = getUserAllowanceData.food_allowance ? getUserAllowanceData.food_allowance : 0;
                        
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};


User.getUserAllowanceData = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        
        var whereCondition = '';
        
        var queryString = "SELECT tg_system_users_allowance.* FROM ?? WHERE  tg_system_users_allowance.user_id = ? "+ whereCondition
        var filter = ['tg_system_users_allowance', postData.user_id];
        
        // console.log('queryString',queryString);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


User.insertUserAllowanceData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            user_id : postData.user_id ? postData.user_id : 0,
            te_flight : postData.te_flight ? postData.te_flight : 0,
            te_train : postData.te_train ? postData.te_train : 0,
            te_bus : postData.te_bus ? postData.te_bus : 0,
            lc_metro_train : postData.lc_metro_train ? postData.lc_metro_train : 0,
            lc_bus : postData.lc_bus ? postData.lc_bus : 0,
            lc_auto : postData.lc_auto ? postData.lc_auto : 0,
            lc_taxi : postData.lc_taxi ? postData.lc_taxi : 0,
            car_per_km : postData.car_per_km ? postData.car_per_km : 0,
            bike_per_km : postData.bike_per_km ? postData.bike_per_km : 0,
            hotel_allowance : postData.hotel_allowance ? postData.hotel_allowance : 0,
            food_allowance : postData.food_allowance ? postData.food_allowance : 0,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_system_users_allowance set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


User.updateUserAllowanceData = function (postData) {
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            te_flight : postData.te_flight ? postData.te_flight : 0,
            te_train : postData.te_train ? postData.te_train : 0,
            te_bus : postData.te_bus ? postData.te_bus : 0,
            lc_metro_train : postData.lc_metro_train ? postData.lc_metro_train : 0,
            lc_bus : postData.lc_bus ? postData.lc_bus : 0,
            lc_auto : postData.lc_auto ? postData.lc_auto : 0,
            lc_taxi : postData.lc_taxi ? postData.lc_taxi : 0,
            car_per_km : postData.car_per_km ? postData.car_per_km : 0,
            bike_per_km : postData.bike_per_km ? postData.bike_per_km : 0,
            hotel_allowance : postData.hotel_allowance ? postData.hotel_allowance : 0,
            food_allowance : postData.food_allowance ? postData.food_allowance : 0,
            updated_on: nowDateTime,   
        };
        
        var queryString = "UPDATE ?? SET ? WHERE user_id = ?;"
        var filter = ["tg_system_users_allowance", updateDataValues, postData.user_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

// allowance code end

module.exports = User;
