var db = require('../../config/db');
var path = require('path');
var moment = require('moment');
var http = require("https");
var request = require('request');
let jwt = require('jsonwebtoken');
var md5 = require('md5');
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');


var Vendor = function (data) {
    
};


Vendor.getVendorCount = function (postData) {
    
    return new Promise(function (resolve, reject) { 
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (company_name LIKE '%"+postData.filter.search+"%'  OR vendor_code LIKE '%"+postData.filter.search+"%' OR mobile LIKE '%"+postData.filter.search+"%' )"; 
        }
        if(postData.filter.company_name){
            whereCondition += " AND (company_name LIKE '%"+postData.filter.company_name+"%')"; 
        }
        if(postData.filter.vendor_code){
            whereCondition += " AND (vendor_code LIKE '%"+postData.filter.vendor_code+"%')"; 
        }
        if(postData.filter.email){
            whereCondition += " AND (email LIKE '%"+postData.filter.email+"%')"; 
        }
        if(postData.filter.street){
            whereCondition += " AND (street LIKE '%"+postData.filter.street+"%')"; 
        }
        if(postData.filter.district_name){
            whereCondition += " AND (district_name LIKE '%"+postData.filter.district_name+"%')"; 
        }
        if(postData.filter.state_name){
            whereCondition += " AND (state_name LIKE '%"+postData.filter.state_name+"%')"; 
        }
        if(postData.filter.mobile){
            whereCondition += " AND (mobile LIKE '%"+postData.filter.mobile+"%')"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (created_on = '"+postData.filter.created_on+"')"; 
        }
        
        var queryString = "SELECT IF(COUNT(id),COUNT(id),0) as totalCount FROM tg_vendor WHERE  deleted = ? AND 1 = 1 "+ whereCondition
        var filter = [0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0].totalCount;
                }
                resolve(data);
            }
        });
    });
};


Vendor.getVendorList = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var whereCondition = '';
        if(postData.filter.search){
            whereCondition += " AND (company_name LIKE '%"+postData.filter.search+"%'  OR vendor_code LIKE '%"+postData.filter.search+"%' OR mobile LIKE '%"+postData.filter.search+"%' )"; 
        }
        if(postData.filter.company_name){
            whereCondition += " AND (company_name LIKE '%"+postData.filter.company_name+"%')"; 
        }
        if(postData.filter.vendor_code){
            whereCondition += " AND (vendor_code LIKE '%"+postData.filter.vendor_code+"%')"; 
        }
        if(postData.filter.email){
            whereCondition += " AND (email LIKE '%"+postData.filter.email+"%')"; 
        }
        if(postData.filter.street){
            whereCondition += " AND (street LIKE '%"+postData.filter.street+"%')"; 
        }
        if(postData.filter.district_name){
            whereCondition += " AND (district_name LIKE '%"+postData.filter.district_name+"%')"; 
        }
        if(postData.filter.state_name){
            whereCondition += " AND (state_name LIKE '%"+postData.filter.state_name+"%')"; 
        }
        if(postData.filter.mobile){
            whereCondition += " AND (mobile LIKE '%"+postData.filter.mobile+"%')"; 
        }
        if(postData.filter.created_on){
            whereCondition += " AND (created_on = '"+postData.filter.created_on+"')"; 
        }
        // console.log('whereCondition',whereCondition);
        var queryString = "SELECT *  FROM tg_vendor WHERE deleted = ? AND  1 = 1 "+ whereCondition +" ORDER BY status DESC, company_name ASC LIMIT ? OFFSET ? ";
        var filter = [0, postData.limit, postData.start];
        
        console.log('queryString',queryString);
        console.log('filter',filter);
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var i = res.length - 1;
                if(res.length){
                    res.forEach(x => {
                        x.encrypt_id = encrypt(x.id.toString());
                        if(i==0){
                            resolve(res);
                        }
                        i--;
                    });
                }else{
                    resolve(res);
                }
            }
        });
    });
};



Vendor.addVendorData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            company_name: postData.company_name ? postData.company_name : '',
            vendor_code: postData.vendor_code ? postData.vendor_code : null,
            email: postData.email ? postData.email : '',
            mobile: postData.mobile ? postData.mobile : '',
            landline_no: postData.landline_no ? postData.landline_no : '',
            gst_no: postData.gst_no ? postData.gst_no : '',
            username: postData.username ? postData.username : '',
            password: postData.password ? postData.password : '',
            street: postData.street ? postData.street : '',
            state_name: postData.state_name ? postData.state_name : '',
            district_name: postData.district_name ? postData.district_name : '',
            city: postData.city ? postData.city : '',
            pincode: postData.pincode ? postData.pincode : '',
            status: postData.status ? postData.status : 0,
            credit_day: postData.credit_day ? postData.credit_day : 0,
            updated_on: nowDateTime,
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_vendor set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Vendor.addVendorContactData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        const valueData = [];
        // console.log('postData',postData);
        if (postData.contactDetail.length > 0) {
            postData.contactDetail.forEach(async x => {
                valueData.push([postData.vendor_id, x.name ? x.name : '', x.email ? x.email : '', x.mobile ? x.mobile : '', x.designation ? x.designation : '', nowDateTime, nowDateTime]); 
            });
            
            var sql = "INSERT INTO tg_vendor_contact (vendor_id,name, email, mobile, designation, updated_on, created_on) VALUES ?";
            db.query(sql, [valueData], function (err, res) {
                if (err) {
                    console.log("error: ", err);
                    return reject(err);
                } else {
                    resolve(res);
                }
            });
        } else {
            resolve([]);
        }
        
    });
}



Vendor.updateVendorData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            company_name: postData.company_name ? postData.company_name : '',
            vendor_code: postData.vendor_code ? postData.vendor_code : null,
            email: postData.email ? postData.email : '',
            gst_no: postData.gst_no ? postData.gst_no : '',
            mobile: postData.mobile ? postData.mobile : '',
            landline_no: postData.landline_no ? postData.landline_no : '',
            username: postData.username ? postData.username : '',
            password: postData.password ? postData.password : '',
            street: postData.street ? postData.street : '',
            state_name: postData.state_name ? postData.state_name : '',
            district_name: postData.district_name ? postData.district_name : '',
            city: postData.city ? postData.city : '',
            pincode: postData.pincode ? postData.pincode : '',
            status: postData.status ? postData.status : 0,
            credit_day: postData.credit_day ? postData.credit_day : 0,
            updated_on: nowDateTime, 
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_vendor", updateDataValues, postData.vendor_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Vendor.updateVendorContactData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            name: postData.name ? postData.name : '',
            email: postData.email ? postData.email : '',
            designation: postData.designation ? postData.designation : '',
            mobile: postData.mobile ? postData.mobile : '',
            updated_on: nowDateTime,
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_vendor_contact", updateDataValues, postData.contact_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

Vendor.addVendorLogData = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var insertData = {
            vendor_id: postData.vendor_id ? postData.vendor_id : 0,
            type: postData.type ? postData.type : '',
            description: postData.description ? postData.description : '',
            created_on: nowDateTime
        }
        
        var queryString = "INSERT INTO tg_vendor_log set ?";
        
        db.query(queryString, insertData, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Vendor.getVendorBasicDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_vendor WHERE  id = ?"
        var filter = [postData.vendor_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                var data = {};
                if(res.length){
                    data = res[0];
                }
                resolve(data);
            }
        });
    });
};


Vendor.getVendorContactDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_vendor_contact WHERE  vendor_id = ? AND deleted = ? ORDER BY id DESC"
        var filter = [postData.vendor_id, 0];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Vendor.getVendorLogDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var queryString = "SELECT * FROM tg_vendor_log WHERE  vendor_id = ? ORDER BY id DESC"
        var filter = [postData.vendor_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};



Vendor.vendorDelete = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            deleted : 1,
            updated_on: nowDateTime,
        }
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_vendor", updateDataValues, postData.vendor_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};


Vendor.deleteVendorContactDetail = function (postData) {
    
    return new Promise(function (resolve, reject) {
        
        var nowDateTime = moment(new Date()).format('YYYY-MM-DD HH:mm:ss');
        
        var updateDataValues = {
            updated_on : nowDateTime,
            deleted : 1
        }
        
        var queryString = "UPDATE ?? SET ? WHERE id = ?;"
        var filter = ["tg_vendor_contact", updateDataValues, postData.contact_id];
        
        db.query(queryString, filter, function (err, res) {
            if (err) {
                console.log("error: ", err);
                return reject(err);
            }
            else {
                resolve(res);
            }
        });
    });
};

module.exports = Vendor;
